"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AlertType = void 0;
const react_1 = __importStar(require("react"));
var AlertType;
(function (AlertType) {
    AlertType["SUCCESS"] = "SUCCESS";
    AlertType["DANGER"] = "DANGER";
})(AlertType = exports.AlertType || (exports.AlertType = {}));
const Alert = (props) => {
    const { type, children, onClose } = props;
    const [isClosed, setIsClosed] = (0, react_1.useState)(false);
    const defaultOnClose = (event) => {
        event.preventDefault();
        setIsClosed(true);
    };
    return isClosed ? (react_1.default.createElement(react_1.default.Fragment, null)) : (react_1.default.createElement("div", { className: `alert alert-${type === AlertType.DANGER ? 'danger' : 'success'} alert-dismissible fade show`, role: "alert" },
        type === AlertType.SUCCESS && (react_1.default.createElement("svg", { className: "bi flex-shrink-0 me-2", width: "24", height: "24", role: "img", "aria-label": "Success:" },
            react_1.default.createElement("use", { xlinkHref: "#check-circle-fill" }))),
        type === AlertType.DANGER && (react_1.default.createElement("svg", { className: "bi flex-shrink-0 me-2", width: "24", height: "24", role: "img", "aria-label": "Danger:" },
            react_1.default.createElement("use", { xlinkHref: "#exclamation-triangle-fill" }))),
        children,
        react_1.default.createElement("button", { type: "button", className: "btn-close", "data-dismiss": "alert", "aria-label": "Close", onClick: onClose ?? defaultOnClose })));
};
exports.default = Alert;
