"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
let uniqueId = 0;
const gen = () => {
    uniqueId += 2;
    return `checkbox_${uniqueId}`;
};
const Checkbox = (props) => {
    const onChange = () => {
        const { value } = props;
        if (props.onChange) {
            props.onChange(!value);
        }
    };
    const { value, label, className, id } = props;
    const uid = id ?? gen();
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: `form-check form-switch d-sm-none${className ? ' ' + className : ''}` },
            react_1.default.createElement("input", { type: "checkbox", className: "form-check-input", checked: value, onChange: onChange, id: uid }),
            react_1.default.createElement("label", { className: "form-check-label", htmlFor: uid }, label ? label : '')),
        react_1.default.createElement("div", { className: `form-check d-none d-sm-block${className ? ' ' + className : ''}` },
            react_1.default.createElement("input", { type: "checkbox", className: "form-check-input", checked: value, onChange: onChange, id: uid + 1 }),
            react_1.default.createElement("label", { className: "form-check-label", htmlFor: uid + 1 }, label ? label : ''))));
};
exports.default = Checkbox;
