"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_prism_editor_1 = __importDefault(require("react-prism-editor"));
const app_1 = require("../contexts/app");
const Editor = (props) => {
    const { id, value, language, readonly, width, height, onChange } = props;
    const app = (0, app_1.useApp)();
    let theme = 'default';
    if (app.theme === 'dark') {
        theme = 'tomorrow';
    }
    else if (app.theme === 'sepia') {
        theme = 'solarizedlight';
    }
    return (react_1.default.createElement(react_prism_editor_1.default, { id: id, style: {
            height: height ? height + 'px' : '100%',
            width: width ? width + 'px' : '100%',
        }, language: language ?? 'html', theme: theme, code: value, lineNumber: readonly !== true && language && language !== 'html', readOnly: readonly === true, clipboard: false, changeCode: (value) => {
            onChange?.(value);
        } }));
};
exports.default = Editor;
