"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const _1 = require(".");
const react_2 = require("react");
const react_3 = require("react");
const src_1 = __importDefault(require("../../../uniflow-flow-function/src"));
const src_2 = __importDefault(require("../../../uniflow-flow-prompt/src"));
const src_3 = __importDefault(require("../../../uniflow-flow-assets/src"));
const src_4 = __importDefault(require("../../../uniflow-flow-text/src"));
const src_5 = __importDefault(require("../../../uniflow-flow-canvas/src"));
const src_6 = __importDefault(require("../../../uniflow-flow-object/src"));
const flowImports = {
    '@uniflow-io/uniflow-flow-function': src_1.default,
    '@uniflow-io/uniflow-flow-prompt': src_2.default,
    '@uniflow-io/uniflow-flow-text': src_4.default,
    '@uniflow-io/uniflow-flow-assets': src_3.default,
    '@uniflow-io/uniflow-flow-canvas': src_5.default,
    '@uniflow-io/uniflow-flow-object': src_6.default,
};
const Flows = (0, react_2.forwardRef)((props, ref) => {
    const { graph, onPush, onPop, onUpdate, onPlay, programFlows, clients } = props;
    const flowRefs = (0, react_1.useMemo)(() => Array(graph.flows.length).fill(null).map(() => (0, react_3.createRef)()), [graph.flows]);
    (0, react_1.useImperativeHandle)(ref, () => ({
        onSerialize: (index) => {
            return flowRefs[index].current?.onSerialize();
        },
        onDeserialize: (index, data) => {
            return flowRefs[index].current?.onDeserialize(data);
        },
        onCompile: (index, client) => {
            return flowRefs[index].current?.onCompile(client) || '';
        },
        onExecute: async (index, runner) => {
            return flowRefs[index].current?.onExecute(runner);
        }
    }), [graph.flows]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(_1.Search, { programFlows: programFlows, onPush: (flowType) => {
                onPush(0, flowType);
            } }),
        graph.flows.map((flow, index) => {
            const Flow = flowImports[flow.type];
            return (react_1.default.createElement(react_1.default.Fragment, { key: index },
                react_1.default.createElement(Flow, { ref: flowRefs[index], clients: clients, isPlaying: flow.isPlaying, data: flow.data, onPop: () => {
                        onPop(index);
                    }, onUpdate: (data) => {
                        onUpdate(index, data);
                    }, onPlay: () => {
                        onPlay(index);
                    } }),
                react_1.default.createElement(_1.Search, { programFlows: programFlows, onPush: (flowType) => {
                        onPush(index + 1, flowType);
                    } })));
        })));
});
exports.default = Flows;
