"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
const free_brands_svg_icons_1 = require("@fortawesome/free-brands-svg-icons");
const router_1 = require("@reach/router");
const react_helmet_1 = __importDefault(require("react-helmet"));
const gatsby_1 = require("gatsby");
const routes_1 = __importStar(require("../routes"));
const _1 = require(".");
const logs_1 = require("../contexts/logs");
const user_1 = require("../contexts/user");
const user_2 = require("../contexts/user");
const contexts_1 = require("../contexts");
const container_1 = __importDefault(require("../container"));
const services_1 = require("../services");
const services_2 = require("../services");
const react_2 = require("react");
const api_type_interfaces_1 = require("../models/api-type-interfaces");
const alert_1 = __importStar(require("../components/alert"));
const container = new container_1.default();
const path = container.get(services_1.Path);
const env = container.get(services_2.Env);
const MessengerPlatform = () => {
    return (react_1.default.createElement("div", null,
        react_1.default.createElement(react_helmet_1.default, null,
            react_1.default.createElement("script", { type: "text/javascript", src: `
          window.fbAsyncInit = function() {
              FB.init({
                xfbml            : true,
                version          : 'v3.2'
              });
            };

            (function(d, s, id) {
            var js, fjs = d.getElementsByTagName(s)[0];
            if (d.getElementById(id)) return;
            js = d.createElement(s); js.id = id;
            js.src = 'https://connect.facebook.net/en_US/sdk/xfbml.customerchat.js';
            fjs.parentNode.insertBefore(js, fjs);
          }(document, 'script', 'facebook-jssdk'));
          ` })),
        react_1.default.createElement("div", { id: "fb-root" }),
        react_1.default.createElement('div', {
            className: 'fb-customerchat',
            attribution: 'setup_tool',
            page_id: '1899593680350111',
        })));
};
const DisplayLog = (props) => {
    const { log } = props;
    const { logsDispatch } = (0, contexts_1.useLogs)();
    (0, react_2.useEffect)(() => {
        setTimeout(() => {
            (0, logs_1.commitReadLog)(log.id)(logsDispatch);
        }, 5000);
    }, []);
    const onClose = (event) => {
        event.preventDefault();
        (0, logs_1.commitReadLog)(log.id)(logsDispatch);
    };
    return (react_1.default.createElement(alert_1.default, { type: alert_1.AlertType.DANGER, onClose: onClose }, log.message));
};
const DisplayLogs = () => {
    const { logs } = (0, contexts_1.useLogs)();
    const newLogs = (0, logs_1.getNewLogs)(logs);
    return (react_1.default.createElement(react_1.default.Fragment, null, Object.keys(newLogs).map((log, index) => (react_1.default.createElement(DisplayLog, { key: index, log: logs[log] })))));
};
const Header = (props) => {
    const { logo, changeLogTags } = props;
    const app = (0, contexts_1.useApp)();
    const { auth } = (0, contexts_1.useAuth)();
    const { user, userDispatch } = (0, contexts_1.useUser)();
    const { authDispatch } = (0, contexts_1.useAuth)();
    const location = (0, router_1.useLocation)();
    const onLocation = (location) => {
        if (path.matchPath(location.pathname, {
            path: routes_1.default.home.path,
            exact: true,
        })) {
            return 'home';
        }
        else if (path.matchPath(location.pathname, {
            path: routes_1.default.flows.path,
            exact: true,
        })) {
            return 'flows';
        }
        else if (path.matchPath(location.pathname, {
            path: routes_1.default.doc.path,
            exact: true,
        })) {
            return 'doc';
        }
        else if (path.matchPath(location.pathname, {
            path: routes_1.default.settings.path,
            exact: true,
        })) {
            return 'settings';
        }
        else if (path.matchPath(location.pathname, {
            path: routes_1.default.admin.path,
            exact: true,
        })) {
            return 'admin';
        }
        else if (path.matchPath(location.pathname, {
            path: routes_1.default.blog.path,
            exact: true,
        }) ||
            path.matchPath(location.pathname, {
                path: routes_1.default.article.path,
            }) ||
            path.matchPath(location.pathname, {
                path: routes_1.default.contributor.path,
            }) ||
            path.matchPath(location.pathname, {
                path: routes_1.default.tags.path,
                exact: true,
            }) ||
            path.matchPath(location.pathname, {
                path: routes_1.default.tag.path,
            })) {
            return 'blog';
        }
        else if (path.matchPath(location.pathname, {
            path: routes_1.default.library.path,
            exact: true,
        }) ||
            path.matchPath(location.pathname, {
                path: routes_1.default.card.path,
            })) {
            return 'library';
        }
        else if (path.matchPath(location.pathname, {
            path: routes_1.default.changelog.path,
            exact: true,
        })) {
            return 'changelog';
        }
        else if (path.matchPath(location.pathname, {
            path: routes_1.default.contact.path,
            exact: true,
        })) {
            return 'contact';
        }
        else if (path.matchPath(location.pathname, {
            path: routes_1.default.login.path,
            exact: true,
        }) ||
            path.matchPath(location.pathname, {
                path: routes_1.default.register.path,
                exact: true,
            })) {
            return 'login';
        }
        else if (path.matchPath(location.pathname, {
            path: routes_1.default.feed.path,
        }) ||
            path.matchPath(location.pathname, {
                path: routes_1.default.userFeed.path,
            })) {
            return 'dashboard';
        }
        return null;
    };
    const onLogout = (event) => {
        event.preventDefault();
        (0, user_1.commitLogoutUser)()(userDispatch, authDispatch);
    };
    const active = onLocation(location);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("header", { className: "navbar navbar-top navbar-expand flex-row" },
            react_1.default.createElement(gatsby_1.Link, { className: "navbar-brand mr-0 mr-md-2", "aria-label": "Uniflow", to: (0, routes_1.pathTo)('home') },
                react_1.default.createElement("img", { src: logo.publicURL, width: "36", height: "36", className: "d-block", alt: "Uniflow" })),
            react_1.default.createElement("div", { className: "navbar-nav-scroll d-none d-md-flex" },
                react_1.default.createElement("ul", { className: "navbar-nav bd-navbar-nav flex-row" },
                    react_1.default.createElement("li", { className: "nav-item" },
                        react_1.default.createElement(gatsby_1.Link, { className: `nav-link${active === 'flows' ? ' active' : ''}`, to: (0, routes_1.pathTo)('flows') }, "Flows")),
                    auth.isAuthenticated && (0, user_2.isGranted)(user, api_type_interfaces_1.ROLE.USER) && (react_1.default.createElement("li", { className: "nav-item" },
                        react_1.default.createElement(gatsby_1.Link, { className: `nav-link${active === 'dashboard' ? ' active' : ''}`, to: (0, routes_1.pathTo)('feed') }, "Dashboard"))),
                    react_1.default.createElement("li", { className: "nav-item" },
                        react_1.default.createElement(gatsby_1.Link, { className: `nav-link${active === 'library' ? ' active' : ''}`, to: (0, routes_1.pathTo)('library') }, "Library")),
                    react_1.default.createElement("li", { className: "nav-item" },
                        react_1.default.createElement(gatsby_1.Link, { className: `nav-link${active === 'doc' ? ' active' : ''}`, to: (0, routes_1.pathTo)('doc') }, "Docs")),
                    auth.isAuthenticated && (0, user_2.isGranted)(user, api_type_interfaces_1.ROLE.USER) && (react_1.default.createElement("li", { className: "nav-item" },
                        react_1.default.createElement(gatsby_1.Link, { className: `nav-link${active === 'settings' ? ' active' : ''}`, to: (0, routes_1.pathTo)('settings') }, "Settings"))),
                    auth.isAuthenticated && (0, user_2.isGranted)(user, api_type_interfaces_1.ROLE.SUPER_ADMIN) && (react_1.default.createElement("li", { className: "nav-item" },
                        react_1.default.createElement(gatsby_1.Link, { className: `nav-link${active === 'admin' ? ' active' : ''}`, to: (0, routes_1.pathTo)('admin') }, "Admin"))),
                    react_1.default.createElement("li", { className: "nav-item" },
                        react_1.default.createElement(gatsby_1.Link, { className: `nav-link${active === 'blog' ? ' active' : ''}`, to: (0, routes_1.pathTo)('blog') }, "Blog")))),
            react_1.default.createElement("ul", { className: "navbar-nav flex-row ms-auto" },
                react_1.default.createElement("li", { className: "nav-item" },
                    react_1.default.createElement(gatsby_1.Link, { className: `nav-item nav-link ${active === 'changelog' ? ' active' : ''}`, to: (0, routes_1.pathTo)('changelog') }, changeLogTags.edges[0].node.tag)),
                react_1.default.createElement("li", { className: "nav-item" },
                    react_1.default.createElement("a", { className: "nav-link", href: "https://github.com/uniflow-io/uniflow", target: "_blank", rel: "noopener noreferrer", "aria-label": "GitHub" },
                        react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_brands_svg_icons_1.faGithub }))),
                react_1.default.createElement("li", { className: "nav-item" },
                    react_1.default.createElement("a", { className: "nav-link", href: "https://twitter.com/uniflow_io", target: "_blank", rel: "noopener noreferrer", "aria-label": "Twitter" },
                        react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_brands_svg_icons_1.faTwitter }))),
                react_1.default.createElement("li", { className: "nav-item" },
                    react_1.default.createElement("a", { className: "nav-link", href: "#", "aria-label": "Theme", onClick: (event) => {
                            event.preventDefault();
                            app.switchTheme();
                        } },
                        app.theme === 'light' && (react_1.default.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 24 24", fill: "none", stroke: "currentColor", strokeWidth: "2", strokeLinecap: "round", strokeLinejoin: "round", className: "svg-inline--fa fa-w-16" },
                            react_1.default.createElement("circle", { cx: "12", cy: "12", r: "5" }),
                            react_1.default.createElement("line", { x1: "12", y1: "1", x2: "12", y2: "3" }),
                            react_1.default.createElement("line", { x1: "12", y1: "21", x2: "12", y2: "23" }),
                            react_1.default.createElement("line", { x1: "4.22", y1: "4.22", x2: "5.64", y2: "5.64" }),
                            react_1.default.createElement("line", { x1: "18.36", y1: "18.36", x2: "19.78", y2: "19.78" }),
                            react_1.default.createElement("line", { x1: "1", y1: "12", x2: "3", y2: "12" }),
                            react_1.default.createElement("line", { x1: "21", y1: "12", x2: "23", y2: "12" }),
                            react_1.default.createElement("line", { x1: "4.22", y1: "19.78", x2: "5.64", y2: "18.36" }),
                            react_1.default.createElement("line", { x1: "18.36", y1: "5.64", x2: "19.78", y2: "4.22" }))),
                        app.theme === 'dark' && (react_1.default.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 24 24", fill: "none", stroke: "currentColor", strokeWidth: "2", strokeLinecap: "round", strokeLinejoin: "round", className: "svg-inline--fa fa-w-16" },
                            react_1.default.createElement("path", { d: "M21 12.79A9 9 0 1 1 11.21 3 7 7 0 0 0 21 12.79z" }))),
                        app.theme === 'sepia' && (react_1.default.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 24 24", fill: "none", stroke: "currentColor", strokeWidth: "2", strokeLinecap: "round", strokeLinejoin: "round", className: "svg-inline--fa fa-w-16" },
                            react_1.default.createElement("path", { d: "M18 8h1a4 4 0 0 1 0 8h-1" }),
                            react_1.default.createElement("path", { d: "M2 8h16v9a4 4 0 0 1-4 4H6a4 4 0 0 1-4-4V8z" }),
                            react_1.default.createElement("line", { x1: "6", y1: "1", x2: "6", y2: "4" }),
                            react_1.default.createElement("line", { x1: "10", y1: "1", x2: "10", y2: "4" }),
                            react_1.default.createElement("line", { x1: "14", y1: "1", x2: "14", y2: "4" }))))),
                !auth.isAuthenticated && (react_1.default.createElement("li", { className: "nav-item" },
                    react_1.default.createElement(gatsby_1.Link, { className: `nav-link${active === 'login' ? ' active' : ''}`, to: (0, routes_1.pathTo)('login') }, "Login"))),
                auth.isAuthenticated && (0, user_2.isGranted)(user, api_type_interfaces_1.ROLE.USER) && (react_1.default.createElement("li", { className: "nav-item" },
                    react_1.default.createElement("a", { className: `nav-link`, href: "/logout", onClick: onLogout },
                        react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faPowerOff })))))),
        react_1.default.createElement("ul", { className: "nav nav-bar-bottom fixed-bottom justify-content-center d-flex d-md-none" },
            react_1.default.createElement("li", { className: "nav-item" },
                react_1.default.createElement(gatsby_1.Link, { className: `nav-link${active === 'flows' ? ' active' : ''}`, to: (0, routes_1.pathTo)('flows') }, "Flows")),
            auth.isAuthenticated && (0, user_2.isGranted)(user, api_type_interfaces_1.ROLE.USER) && (react_1.default.createElement("li", { className: "nav-item" },
                react_1.default.createElement(gatsby_1.Link, { className: `nav-link${active === 'dashboard' ? ' active' : ''}`, to: (0, routes_1.pathTo)('feed') }, "Dashboard"))),
            react_1.default.createElement("li", { className: "nav-item" },
                react_1.default.createElement(gatsby_1.Link, { className: `nav-link${active === 'library' ? ' active' : ''}`, to: (0, routes_1.pathTo)('library') }, "Library")),
            react_1.default.createElement("li", { className: "nav-item" },
                react_1.default.createElement(gatsby_1.Link, { className: `nav-link${active === 'doc' ? ' active' : ''}`, to: (0, routes_1.pathTo)('doc') }, "Docs")),
            auth.isAuthenticated && (0, user_2.isGranted)(user, api_type_interfaces_1.ROLE.USER) && (react_1.default.createElement("li", { className: "nav-item" },
                react_1.default.createElement(gatsby_1.Link, { className: `nav-link${active === 'settings' ? ' active' : ''}`, to: (0, routes_1.pathTo)('settings') }, "Settings"))),
            auth.isAuthenticated && (0, user_2.isGranted)(user, api_type_interfaces_1.ROLE.SUPER_ADMIN) && (react_1.default.createElement("li", { className: "nav-item" },
                react_1.default.createElement(gatsby_1.Link, { className: `nav-link${active === 'admin' ? ' active' : ''}`, to: (0, routes_1.pathTo)('admin') }, "Admin"))),
            react_1.default.createElement("li", { className: "nav-item" },
                react_1.default.createElement(gatsby_1.Link, { className: `nav-link${active === 'blog' ? ' active' : ''}`, to: (0, routes_1.pathTo)('blog') }, "Blog")))));
};
const Footer = () => {
    return (react_1.default.createElement("footer", { className: "text-muted d-flex border-top" },
        react_1.default.createElement("div", { className: "container-fluid" },
            react_1.default.createElement("ul", { className: "nav nav-bottom justify-content-end" },
                react_1.default.createElement("li", { className: "nav-item" },
                    react_1.default.createElement(gatsby_1.Link, { className: "nav-link", to: (0, routes_1.pathTo)('contact') }, "Contact"))))));
};
const Layout = (props) => {
    const app = (0, contexts_1.useApp)();
    const environement = env.get('env');
    return (react_1.default.createElement(gatsby_1.StaticQuery, { query: (0, gatsby_1.graphql) `
        query LayoutQuery {
          site {
            siteMetadata {
              title
              description
            }
          }
          logo: file(sourceInstanceName: { eq: "images" }, relativePath: { eq: "logo.svg" }) {
            publicURL
          }
          logoSeo: file(sourceInstanceName: { eq: "images" }, relativePath: { eq: "logo.png" }) {
            publicURL
          }
          changeLogTags: allChangelogYaml(limit: 1) {
            edges {
              node {
                tag
              }
            }
          }
        }
      `, render: ({ site: { siteMetadata }, logo, logoSeo, changeLogTags }) => (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(react_helmet_1.default, null,
                react_1.default.createElement("html", { lang: "en" }),
                react_1.default.createElement("body", { id: app.page, className: `theme-${app.theme}` }),
                react_1.default.createElement("meta", { charSet: "utf-8" }),
                react_1.default.createElement("meta", { name: "viewport", content: "width=device-width, initial-scale=1, shrink-to-fit=no" }),
                react_1.default.createElement("title", null, siteMetadata.title),
                react_1.default.createElement("meta", { name: "description", content: siteMetadata.description }),
                react_1.default.createElement("meta", { property: "og:title", content: siteMetadata.title }),
                react_1.default.createElement("meta", { property: "og:description", content: siteMetadata.description }),
                react_1.default.createElement("meta", { property: "og:url", content: env.get('clientUrl') }),
                react_1.default.createElement("meta", { property: "og:type", content: "website" }),
                react_1.default.createElement("meta", { property: "og:locale", content: "en" }),
                react_1.default.createElement("meta", { property: "og:site_name", content: siteMetadata.title }),
                react_1.default.createElement("meta", { property: "og:image", content: `${env.get('clientUrl')}${logoSeo.publicURL}` }),
                react_1.default.createElement("meta", { property: "og:image:width", content: "512" }),
                react_1.default.createElement("meta", { property: "og:image:height", content: "512" }),
                react_1.default.createElement("meta", { name: "twitter:card", content: "summary_large_image" }),
                react_1.default.createElement("meta", { name: "twitter:site", content: "uniflow_io" }),
                react_1.default.createElement("meta", { name: "twitter:title", content: siteMetadata.title }),
                react_1.default.createElement("meta", { name: "twitter:description", content: siteMetadata.description }),
                react_1.default.createElement("meta", { name: "twitter:image", content: `${env.get('clientUrl')}${logo.publicURL}` })),
            react_1.default.createElement(_1.UserManager, null),
            environement &&
                [
                /*'production', 'preprod'*/
                ].indexOf(environement) !== -1 && react_1.default.createElement(MessengerPlatform, null),
            react_1.default.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", style: { display: 'none' } },
                react_1.default.createElement("symbol", { id: "check-circle-fill", fill: "currentColor", viewBox: "0 0 16 16" },
                    react_1.default.createElement("path", { d: "M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0zm-3.97-3.03a.75.75 0 0 0-1.08.022L7.477 9.417 5.384 7.323a.75.75 0 0 0-1.06 1.06L6.97 11.03a.75.75 0 0 0 1.079-.02l3.992-4.99a.75.75 0 0 0-.01-1.05z" })),
                react_1.default.createElement("symbol", { id: "info-fill", fill: "currentColor", viewBox: "0 0 16 16" },
                    react_1.default.createElement("path", { d: "M8 16A8 8 0 1 0 8 0a8 8 0 0 0 0 16zm.93-9.412-1 4.705c-.07.34.029.533.304.533.194 0 .487-.07.686-.246l-.088.416c-.287.346-.92.598-1.465.598-.703 0-1.002-.422-.808-1.319l.738-3.468c.064-.293.006-.399-.287-.47l-.451-.081.082-.381 2.29-.287zM8 5.5a1 1 0 1 1 0-2 1 1 0 0 1 0 2z" })),
                react_1.default.createElement("symbol", { id: "exclamation-triangle-fill", fill: "currentColor", viewBox: "0 0 16 16" },
                    react_1.default.createElement("path", { d: "M8.982 1.566a1.13 1.13 0 0 0-1.96 0L.165 13.233c-.457.778.091 1.767.98 1.767h13.713c.889 0 1.438-.99.98-1.767L8.982 1.566zM8 5c.535 0 .954.462.9.995l-.35 3.507a.552.552 0 0 1-1.1 0L7.1 5.995A.905.905 0 0 1 8 5zm.002 6a1 1 0 1 1 0 2 1 1 0 0 1 0-2z" })),
                react_1.default.createElement("symbol", { id: "nav-expand", width: "24", height: "24", fill: "currentColor", viewBox: "0 0 24 24" },
                    react_1.default.createElement("path", { fillRule: "evenodd", d: "M1 8a.5.5 0 0 1 .5-.5h13a.5.5 0 0 1 0 1h-13A.5.5 0 0 1 1 8zM7.646.146a.5.5 0 0 1 .708 0l2 2a.5.5 0 0 1-.708.708L8.5 1.707V5.5a.5.5 0 0 1-1 0V1.707L6.354 2.854a.5.5 0 1 1-.708-.708l2-2zM8 10a.5.5 0 0 1 .5.5v3.793l1.146-1.147a.5.5 0 0 1 .708.708l-2 2a.5.5 0 0 1-.708 0l-2-2a.5.5 0 0 1 .708-.708L7.5 14.293V10.5A.5.5 0 0 1 8 10z" })),
                react_1.default.createElement("symbol", { id: "nav-collapse", width: "24", height: "24", fill: "currentColor", viewBox: "0 0 24 24" },
                    react_1.default.createElement("path", { fillRule: "evenodd", d: "M1 8a.5.5 0 0 1 .5-.5h13a.5.5 0 0 1 0 1h-13A.5.5 0 0 1 1 8zm7-8a.5.5 0 0 1 .5.5v3.793l1.146-1.147a.5.5 0 0 1 .708.708l-2 2a.5.5 0 0 1-.708 0l-2-2a.5.5 0 1 1 .708-.708L7.5 4.293V.5A.5.5 0 0 1 8 0zm-.5 11.707l-1.146 1.147a.5.5 0 0 1-.708-.708l2-2a.5.5 0 0 1 .708 0l2 2a.5.5 0 0 1-.708.708L8.5 11.707V15.5a.5.5 0 0 1-1 0v-3.793z" }))),
            react_1.default.createElement(Header, { logo: logo, changeLogTags: changeLogTags }),
            react_1.default.createElement(DisplayLogs, null),
            props.children,
            react_1.default.createElement(Footer, null))) }));
};
exports.default = Layout;
