"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_2 = require("@mdx-js/react");
const gatsby_1 = require("gatsby");
const components_1 = require("../components");
const components = {
    h1: (props) => (react_1.default.createElement("h3", { className: 'mb-3', ...props }, props.children)),
    h2: (props) => react_1.default.createElement("h4", { ...props }, props.children),
    h3: (props) => react_1.default.createElement("h5", { ...props }, props.children),
    h4: (props) => react_1.default.createElement("h5", { ...props }, props.children),
    a: (props) => {
        if (props.href.indexOf('https://uniflow.io') === 0) {
            const to = props.href.slice('https://uniflow.io'.length);
            return react_1.default.createElement(gatsby_1.Link, { to: to.length === 0 ? '/' : to }, props.children);
        }
        return (react_1.default.createElement("a", { href: props.href, target: "_blank", rel: "noopener noreferrer" }, props.children));
    },
    img: (props) => (react_1.default.createElement("span", { className: "d-flex" },
        react_1.default.createElement("img", { className: "img-fluid mx-auto", alt: props.alt, ...props }))),
    Link: gatsby_1.Link,
    code: (props) => {
        let language = 'html';
        if (props.className === 'language-javascript') {
            language = 'javascript';
        }
        if (props.className === 'language-jsx') {
            language = 'jsx';
        }
        return react_1.default.createElement(components_1.Editor, { language: language, readonly: true, value: props.children });
    },
};
exports.default = (props) => (react_1.default.createElement(react_2.MDXProvider, { components: components }, props.children));
