"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const user_1 = require("../contexts/user");
const routes_1 = require("../routes");
const feed_1 = require("../contexts/feed");
const react_2 = require("react");
const router_1 = require("@reach/router");
const contexts_1 = require("../contexts");
const UserManager = (props) => {
    const [isFetching, setIsFetching] = (0, react_1.useState)(false);
    const { auth, authDispatch } = (0, contexts_1.useAuth)();
    const { userDispatch } = (0, contexts_1.useUser)();
    const { feed, feedDispatch } = (0, feed_1.useFeed)();
    const location = (0, router_1.useLocation)();
    const isCachedFeed = (uid, paths = []) => {
        if (feed.uid === undefined ||
            feed.slug === undefined ||
            feed.parentFolder === undefined ||
            feed.uid !== uid) {
            return false;
        }
        const path = `/${paths.join('/')}`;
        const parentPath = `/${paths.slice(0, -1).join('/')}`;
        const slug = paths.length > 0 ? paths[paths.length - 1] : null;
        const item = (0, feed_1.getFeedItem)(feed, slug);
        if (paths.length === 0 && feed.parentFolder === null) {
            return true;
        }
        else if (paths.length === 1 && feed.parentFolder === null) {
            if (item && item.type === 'folder') {
                return false;
            }
            (0, feed_1.commitSetSlugFeed)(slug)(feedDispatch);
            return true;
        }
        else if (paths.length === 1 && feed.parentFolder) {
            const parentFolderRealPath = `${feed.parentFolder.path === '/' ? '' : feed.parentFolder.path}/${feed.parentFolder.slug}`;
            if (parentFolderRealPath === path) {
                (0, feed_1.commitSetSlugFeed)(null)(feedDispatch);
                return true;
            }
        }
        else if (paths.length > 1 && feed.parentFolder) {
            const parentFolderRealPath = `${feed.parentFolder.path === '/' ? '' : feed.parentFolder.path}/${feed.parentFolder.slug}`;
            if (parentFolderRealPath === path) {
                (0, feed_1.commitSetSlugFeed)(null)(feedDispatch);
                return true;
            }
            else if (parentFolderRealPath === parentPath) {
                if (item && item.type === 'folder') {
                    return false;
                }
                (0, feed_1.commitSetSlugFeed)(slug)(feedDispatch);
                return true;
            }
        }
        return false;
    };
    const onFetchItem = async (uid, paths = []) => {
        if (isFetching || isCachedFeed(uid, paths)) {
            return;
        }
        setIsFetching(true);
        const token = auth.isAuthenticated ? auth.token : undefined;
        await (0, feed_1.fetchFeed)(uid, paths, token)(feedDispatch, userDispatch, authDispatch);
        setIsFetching(false);
    };
    const onLocation = async (location) => {
        const match = (0, routes_1.matchRoute)(location.pathname);
        if (match) {
            const params = match.match.params;
            const paths = [params.slug1, params.slug2, params.slug3, params.slug4, params.slug5].filter((path) => !!path);
            if (match.route === 'feed' && auth.isAuthenticated && auth.uid) {
                await onFetchItem(auth.uid, paths);
            }
            else if (match.route === 'userFeed') {
                await onFetchItem(params.uid, paths);
            }
        }
    };
    const onFetchUser = async (uid, token) => {
        await Promise.all([(0, user_1.fetchSettings)(uid, token)(userDispatch, authDispatch)]);
    };
    (0, react_2.useEffect)(() => {
        if (auth.isAuthenticated && auth.uid && auth.token) {
            onFetchUser(auth.uid, auth.token);
        }
    }, [auth.token]);
    (0, react_2.useEffect)(() => {
        onLocation(location);
    }, [location]);
    return react_1.default.createElement(react_1.default.Fragment, null);
};
exports.default = UserManager;
