"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const convict_1 = __importDefault(require("convict"));
const dotenv = __importStar(require("dotenv"));
const activeEnv = process.env.GATSBY_ACTIVE_ENV || process.env.NODE_ENV || 'development';
const envFound = dotenv.config({
    path: `.env.${activeEnv}`,
});
if (!envFound) {
    // Throw generic error
    throw new Error(`Couldn't find .env.${activeEnv} file`);
}
const appConfig = (0, convict_1.default)({
    env: {
        doc: 'Running environment',
        format: ['development', 'preprod', 'production', 'test'],
        default: 'development',
        env: 'NODE_ENV',
    },
    port: {
        format: Number,
        default: 8016,
        arg: 'port',
        env: 'PORT',
        doc: 'HTTP port uniflow api can be reached',
    },
    clientUrl: {
        format: String,
        default: '',
        env: 'GATSBY_CLIENT_URL',
        doc: 'Client',
    },
    apiUrl: {
        format: String,
        default: '',
        env: 'GATSBY_API_URL',
        doc: 'Api Url',
    },
    facebookAppId: {
        format: String,
        default: '',
        env: 'GATSBY_FACEBOOK_APP_ID',
        doc: 'Facebook App Id',
    },
    githubAppId: {
        format: String,
        default: '',
        env: 'GATSBY_GITHUB_APP_ID',
        doc: 'Github App Id',
    },
    matomoSiteId: {
        format: String,
        default: '',
        env: 'GATSBY_MATOMO_SITE_ID',
        doc: 'Matomo Site Id',
    },
    matomoUrl: {
        format: String,
        default: '',
        env: 'GATSBY_MATOMO_URL',
        doc: 'Matomo URL',
    }
});
appConfig.validate({
    allowed: 'strict',
});
exports.default = appConfig;
