"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useApp = exports.AppConsumer = exports.AppProvider = exports.AppContext = void 0;
const react_1 = __importStar(require("react"));
exports.AppContext = react_1.default.createContext({
    page: 'home',
    theme: 'light',
    setPage: () => {
        throw new Error('AppContext not yet initialized.');
    },
    switchTheme: () => {
        throw new Error('AppContext not yet initialized.');
    },
});
exports.AppContext.displayName = 'AppContext';
const AppProvider = (props) => {
    const [page, setPage] = (0, react_1.useState)('home');
    const [theme, setTheme] = (0, react_1.useState)('light');
    (0, react_1.useEffect)(() => {
        setTheme(JSON.parse(localStorage.getItem('theme') || '"light"'));
    });
    return (react_1.default.createElement(exports.AppContext.Provider, { value: {
            page,
            theme,
            setPage,
            switchTheme: () => {
                let switchTheme = 'light';
                if (theme === 'light') {
                    switchTheme = 'dark';
                }
                else if (theme === 'dark') {
                    switchTheme = 'sepia';
                }
                else if (theme === 'sepia') {
                    switchTheme = 'light';
                }
                setTheme(switchTheme);
                localStorage.setItem('theme', JSON.stringify(switchTheme));
            },
        } }, props.children));
};
exports.AppProvider = AppProvider;
exports.AppConsumer = exports.AppContext.Consumer;
function useApp() {
    return (0, react_1.useContext)(exports.AppContext);
}
exports.useApp = useApp;
