"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useLogs = exports.LogsConsumer = exports.LogsProvider = exports.LogsContext = exports.commitReadLog = exports.commitAddLog = exports.getNewLogs = exports.LogsActionTypes = void 0;
const react_1 = __importStar(require("react"));
const use_reducer_ref_1 = require("../hooks/use-reducer-ref");
const models_1 = require("../models");
const log_1 = require("../models/log");
var LogsActionTypes;
(function (LogsActionTypes) {
    LogsActionTypes["COMMIT_ADD_LOG"] = "COMMIT_ADD_LOG";
    LogsActionTypes["COMMIT_READ_LOG"] = "COMMIT_READ_LOG";
})(LogsActionTypes = exports.LogsActionTypes || (exports.LogsActionTypes = {}));
let logId = 0;
const defaultState = {};
const getNewLogs = (logs) => {
    return Object.keys(logs).reduce((newLogs, key) => {
        if (logs[key].status === log_1.LOG_STATUS.NEW) {
            newLogs[key] = logs[key];
        }
        return newLogs;
    }, {});
};
exports.getNewLogs = getNewLogs;
const commitAddLog = (message) => {
    return (dispatch) => {
        dispatch({
            type: LogsActionTypes.COMMIT_ADD_LOG,
            message,
        });
    };
};
exports.commitAddLog = commitAddLog;
const commitReadLog = (id) => {
    return (dispatch) => {
        dispatch({
            type: LogsActionTypes.COMMIT_READ_LOG,
            id,
        });
    };
};
exports.commitReadLog = commitReadLog;
exports.LogsContext = react_1.default.createContext({
    logs: defaultState,
    logsDispatch: () => {
        throw new Error('LogContext not yet initialized.');
    },
    logsRef: {
        current: defaultState,
    },
});
exports.LogsContext.displayName = 'LogContext';
const LogsProvider = (props) => {
    const [logs, logsDispatch, logsRef] = (0, use_reducer_ref_1.useReducerRef)((state = defaultState, action) => {
        switch (action.type) {
            case LogsActionTypes.COMMIT_ADD_LOG:
                return {
                    ...state,
                    ...{
                        [logId]: new models_1.Log({
                            id: logId++,
                            message: action.message,
                            status: log_1.LOG_STATUS.NEW,
                        }),
                    },
                };
            case LogsActionTypes.COMMIT_READ_LOG:
                return {
                    ...state,
                    ...{
                        [action.id]: new models_1.Log({
                            id: action.id,
                            message: state[action.id].message,
                            status: log_1.LOG_STATUS.READ,
                        }),
                    },
                };
            default:
                return state;
        }
    }, defaultState);
    return (react_1.default.createElement(exports.LogsContext.Provider, { value: { logs, logsDispatch, logsRef } }, props.children));
};
exports.LogsProvider = LogsProvider;
exports.LogsConsumer = exports.LogsContext.Consumer;
function useLogs() {
    return (0, react_1.useContext)(exports.LogsContext);
}
exports.useLogs = useLogs;
