"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const routes_1 = require("../routes");
const user_1 = require("../contexts/user");
const gatsby_1 = require("gatsby");
const contexts_1 = require("../contexts");
const react_2 = require("react");
const api_type_interfaces_1 = require("../models/api-type-interfaces");
function requireAuthentication(Component, role = api_type_interfaces_1.ROLE.USER) {
    const requireAuthenticationHelper = (props) => {
        const { auth } = (0, contexts_1.useAuth)();
        const { user } = (0, user_1.useUser)();
        const checkAuth = (isAuthenticated, user) => {
            if (!isAuthenticated || (user.uid && !(0, user_1.isGranted)(user, role))) {
                if (typeof window !== `undefined`) {
                    (0, gatsby_1.navigate)((0, routes_1.pathTo)('login'));
                }
            }
        };
        (0, react_2.useEffect)(() => {
            checkAuth(auth.isAuthenticated, user);
        }, [auth.token]);
        if (auth.isAuthenticated === true) {
            return react_1.default.createElement(Component, { ...props });
        }
        return null;
    };
    return requireAuthenticationHelper;
}
exports.default = requireAuthentication;
