"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_helmet_1 = __importDefault(require("react-helmet"));
const container_1 = __importDefault(require("../container"));
const services_1 = require("../services");
const react_2 = require("react");
const app_1 = require("../contexts/app");
const router_1 = require("@reach/router");
const container = new container_1.default();
const env = container.get(services_1.Env);
function withPage(Component, page, seo) {
    const PageHelper = (props) => {
        const app = (0, app_1.useApp)();
        const source = (0, router_1.createMemorySource)(seo.location.pathname + seo.location.search);
        const history = (0, router_1.createHistory)(source);
        (0, react_2.useEffect)(() => {
            app.setPage(page);
        });
        return (react_1.default.createElement(react_1.default.Fragment, null,
            seo && (react_1.default.createElement(react_helmet_1.default, null,
                react_1.default.createElement("title", null, seo.title),
                react_1.default.createElement("link", { rel: "canonical", href: `${env.get('clientUrl')}${seo.location.pathname}` }),
                seo.description && react_1.default.createElement("meta", { name: "description", content: seo.description }),
                react_1.default.createElement("meta", { property: "og:title", content: seo.title }),
                seo.description && react_1.default.createElement("meta", { property: "og:description", content: seo.description }),
                react_1.default.createElement("meta", { property: "og:url", content: `${env.get('clientUrl')}${seo.location.pathname}` }),
                seo.type && react_1.default.createElement("meta", { property: "og:type", content: seo.type }),
                seo.title && react_1.default.createElement("meta", { property: "og:title", content: seo.title }),
                seo.image &&
                    typeof seo.image === 'string' && [
                    react_1.default.createElement("meta", { key: "og:image", property: "og:image", content: `${env.get('clientUrl')}${seo.image}` }),
                    react_1.default.createElement("meta", { key: "og:image:width", property: "og:image:width", content: "" }),
                    react_1.default.createElement("meta", { key: "og:image:height", property: "og:image:height", content: "" }),
                ],
                seo.image &&
                    typeof seo.image !== 'string' && [
                    react_1.default.createElement("meta", { key: "og:image", property: "og:image", content: `${env.get('clientUrl')}${seo.image.url}` }),
                    react_1.default.createElement("meta", { key: "og:image:width", property: "og:image:width", content: seo.image.width }),
                    react_1.default.createElement("meta", { key: "og:image:height", property: "og:image:height", content: seo.image.height }),
                ],
                seo.title && react_1.default.createElement("meta", { name: "twitter:title", content: seo.title }),
                seo.description && react_1.default.createElement("meta", { name: "twitter:description", content: seo.description }),
                seo.image && typeof seo.image === 'string' && (react_1.default.createElement("meta", { name: "twitter:image", content: `${env.get('clientUrl')}${seo.image}` })),
                seo.image && typeof seo.image !== 'string' && (react_1.default.createElement("meta", { property: "twitter:image", content: `${env.get('clientUrl')}${seo.image.url}` })))),
            react_1.default.createElement(router_1.LocationProvider, { history: history },
                react_1.default.createElement(Component, { ...props }))));
    };
    return PageHelper;
}
exports.default = withPage;
