"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useReducerRef = void 0;
const react_1 = require("react");
function useReducerRef(reducer, initialState, initializer) {
    const stateRef = (0, react_1.useRef)(initialState);
    const [state, dispatch] = (0, react_1.useReducer)((state, action) => {
        state = reducer(state, action);
        stateRef.current = state;
        return state;
    }, initialState, initializer);
    return [state, dispatch, stateRef];
}
exports.useReducerRef = useReducerRef;
