"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useStateRef = void 0;
const react_1 = require("react");
function useStateRef(initialState) {
    const stateRef = (0, react_1.useRef)(initialState);
    const [state, setState] = (0, react_1.useState)(initialState);
    const dispatch = (0, react_1.useCallback)((val) => {
        stateRef.current = val;
        setState(stateRef.current);
    }, []);
    return [state, dispatch, stateRef];
}
exports.useStateRef = useStateRef;
