"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const console_1 = __importDefault(require("../bridges/console"));
const axios_1 = __importDefault(require("../bridges/axios"));
const vm_1 = __importDefault(require("vm"));
const contexts_1 = require("../contexts");
const interfaces_1 = require("./interfaces");
class Runner {
    async run(flows, flowsRef, graphDispatch) {
        const context = vm_1.default.createContext({
            console: console_1.default,
            axios: axios_1.default,
        });
        for (let index = 0; index < flows.length; index++) {
            const runner = {
                run: () => {
                    const code = flowsRef.current?.onCompile(index, interfaces_1.ClientType.UNIFLOW);
                    return vm_1.default.runInContext(code || '', context);
                },
                getContext: () => {
                    return context;
                },
            };
            (0, contexts_1.commitPlayFlow)(index)(graphDispatch);
            await flowsRef.current?.onExecute(index, runner);
            await new Promise((resolve) => {
                setTimeout(resolve, 500);
            });
            (0, contexts_1.commitStopFlow)(index)(graphDispatch);
        }
    }
}
exports.default = Runner;
