"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = __importDefault(require("express"));
const config_1 = require("./config");
async function server() {
    const port = config_1.appConfig.get('port');
    const app = (0, express_1.default)();
    app.use('/', express_1.default.static('./public'));
    return new Promise((resolve) => {
        app.on('error', (err) => {
            console.log(err);
            process.exit(1);
        });
        app.listen(port, resolve);
    });
}
exports.default = server;
