"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const typedi_1 = require("typedi");
const path_to_regexp_1 = require("path-to-regexp");
const patternCache = {};
const cacheLimit = 10000;
let cacheCount = 0;
let Path = class Path {
    compilePath(pattern, options) {
        const cacheKey = '' + options.end + options.strict + options.sensitive;
        const cache = patternCache[cacheKey] || (patternCache[cacheKey] = {});
        if (cache[pattern])
            return cache[pattern];
        const keys = [];
        const re = (0, path_to_regexp_1.pathToRegexp)(pattern, keys, options);
        const compiledPattern = { re: re, keys: keys };
        if (cacheCount < cacheLimit) {
            cache[pattern] = compiledPattern;
            cacheCount++;
        }
        return compiledPattern;
    }
    matchPath(pathname, options) {
        const parent = arguments[2];
        if (typeof options === 'string')
            options = { path: options };
        const _options = options;
        const path = _options.path;
        const _options$exact = _options.exact;
        const exact = _options$exact === undefined ? false : _options$exact;
        const _options$strict = _options.strict;
        const strict = _options$strict === undefined ? false : _options$strict;
        const _options$sensitive = _options.sensitive;
        const sensitive = _options$sensitive === undefined ? false : _options$sensitive;
        if (path == null)
            return parent;
        const _compilePath = this.compilePath(path, {
            end: exact,
            strict: strict,
            sensitive: sensitive,
        });
        const re = _compilePath.re;
        const keys = _compilePath.keys;
        const match = re.exec(pathname);
        if (!match)
            return null;
        const url = match[0];
        const values = match.slice(1);
        const isExact = pathname === url;
        if (exact && !isExact)
            return null;
        return {
            path: path,
            url: path === '/' && url === '' ? '/' : url,
            isExact: isExact,
            params: keys.reduce(function (memo, key, index) {
                memo[key.name] = values[index];
                return memo;
            }, {}),
        };
    }
};
Path = __decorate([
    (0, typedi_1.Service)()
], Path);
exports.default = Path;
