"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const user_1 = require("../contexts/user");
const react_2 = require("react");
const react_3 = require("react");
const contexts_1 = require("../contexts");
const Admin = () => {
    const [config, setConfig] = (0, react_2.useState)({});
    const [isSaving, setIsSaving] = (0, react_2.useState)(false);
    const { auth, authDispatch } = (0, contexts_1.useAuth)();
    const { userDispatch } = (0, user_1.useUser)();
    const { logsDispatch } = (0, contexts_1.useLogs)();
    (0, react_3.useEffect)(() => {
        (async () => {
            if (auth.token && auth.uid) {
                const data = await (0, user_1.fetchConfig)(auth.token, auth.uid)(userDispatch, authDispatch);
                setConfig(Object.assign({}, config, data));
            }
        })();
    }, []);
    const onUpdate = async () => {
        setIsSaving(true);
        if (auth.token && auth.uid) {
            await (0, user_1.updateConfig)(config, auth.token, auth.uid)(userDispatch, authDispatch, logsDispatch);
        }
        setIsSaving(false);
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("section", { className: "section container-fluid" },
            react_1.default.createElement("h3", { className: "box-title" }, "Admin"),
            react_1.default.createElement("form", { className: "form-sm-horizontal" }))));
};
exports.default = Admin;
