"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const gatsby_1 = require("gatsby");
const gatsby_plugin_mdx_1 = require("gatsby-plugin-mdx");
const gatsby_plugin_image_1 = require("gatsby-plugin-image");
const free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const free_regular_svg_icons_1 = require("@fortawesome/free-regular-svg-icons");
const routes_1 = require("../../routes");
const components_1 = require("../../components");
const Article = (props) => {
    const { article, previous, next } = props;
    return (react_1.default.createElement("section", { className: "section container-fluid" },
        react_1.default.createElement("figure", { className: "figure-fluid" },
            article.frontmatter.cover.childImageSharp && (react_1.default.createElement(gatsby_plugin_image_1.GatsbyImage, { image: article.frontmatter.cover.childImageSharp.gatsbyImageData, className: "figure-img img-fluid", alt: "Cover" })),
            article.frontmatter.cover.extension === 'svg' && (react_1.default.createElement("img", { className: "figure-img img-fluid", src: article.frontmatter.cover.publicURL, alt: "Cover" })),
            react_1.default.createElement("figcaption", { className: "figure-caption text-center" },
                "credit",
                ' ',
                react_1.default.createElement("a", { href: article.frontmatter.coverOriginalUrl, target: "_blank", rel: "noopener noreferrer" }, article.frontmatter.coverAuthor))),
        react_1.default.createElement("h3", { className: "my-4" }, article.frontmatter.title),
        react_1.default.createElement("div", { className: "row pt-4 mb-3" },
            react_1.default.createElement("div", { className: "col-sm-12 text-center" },
                react_1.default.createElement("small", null,
                    "Posted ",
                    article.frontmatter.date,
                    " by",
                    react_1.default.createElement(gatsby_plugin_image_1.GatsbyImage, { image: article.frontmatter.author.image.childImageSharp.gatsbyImageData, alt: article.frontmatter.author.name, className: "rounded-circle mx-2", style: { verticalAlign: 'middle', display: 'inline-block' } }),
                    react_1.default.createElement(gatsby_1.Link, { to: (0, routes_1.pathTo)('contributor', {
                            slug: article.frontmatter.author.fields.slug,
                        }) }, article.frontmatter.author.name),
                    react_1.default.createElement("span", null, " - "),
                    react_1.default.createElement("i", null,
                        article.timeToRead,
                        " min read")))),
        react_1.default.createElement("div", { className: "row mb-3" },
            react_1.default.createElement("div", { className: "col-sm-12" },
                react_1.default.createElement(components_1.MDXProvider, null,
                    react_1.default.createElement(gatsby_plugin_mdx_1.MDXRenderer, null, article.body)),
                react_1.default.createElement("p", null,
                    react_1.default.createElement("a", { href: `https://github.com/uniflow-io/uniflow/blob/1.x/docs/blog/${article.parent.relativePath}`, target: "_blank", rel: "noopener noreferrer" },
                        react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_regular_svg_icons_1.faEdit }),
                        " Edit this page on GitHub")))),
        react_1.default.createElement("div", { className: "row" },
            react_1.default.createElement("div", { className: "col-auto" }, previous && (react_1.default.createElement(gatsby_1.Link, { to: (0, routes_1.pathTo)('article', { slug: previous.fields.slug }), className: "pull-left" },
                react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faArrowLeft }),
                " ",
                previous.frontmatter.title))),
            react_1.default.createElement("div", { className: "col-auto ms-auto" }, next && (react_1.default.createElement(gatsby_1.Link, { to: (0, routes_1.pathTo)('article', { slug: next.fields.slug }), className: "pull-right" },
                next.frontmatter.title,
                " ",
                react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faArrowRight })))))));
};
exports.default = Article;
