"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const gatsby_1 = require("gatsby");
const articleItem_1 = __importDefault(require("./articleItem"));
const Blog = () => (react_1.default.createElement(react_1.default.Fragment, null,
    react_1.default.createElement("section", { className: "section container-fluid" },
        react_1.default.createElement("h3", null, "Blog"),
        react_1.default.createElement(gatsby_1.StaticQuery, { query: (0, gatsby_1.graphql) `
          query ArticlesQuery {
            allMdx(
              filter: { fields: { sourceName: { eq: "blog" } } }
              sort: { fields: frontmatter___date, order: DESC }
            ) {
              edges {
                node {
                  ...ArticleItemFragment
                }
              }
            }
          }
        `, render: (data) => data.allMdx.edges.map((item, i) => (react_1.default.createElement("div", { className: "row mb-3", key: i },
                react_1.default.createElement("div", { className: "col-md-6 offset-md-3" },
                    react_1.default.createElement(articleItem_1.default, { article: item.node }))))) }))));
exports.default = Blog;
