"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const articleItem_1 = __importDefault(require("./articleItem"));
const gatsby_plugin_image_1 = require("gatsby-plugin-image");
const free_brands_svg_icons_1 = require("@fortawesome/free-brands-svg-icons");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const Contributor = (props) => {
    const { contributor, articles } = props;
    return (react_1.default.createElement("section", { className: "section container-fluid" },
        react_1.default.createElement("div", { className: "row mb-3" },
            react_1.default.createElement("div", { className: "col-sm-6 offset-sm-3" },
                react_1.default.createElement("div", { className: "user" },
                    react_1.default.createElement("div", { className: "user-header" },
                        react_1.default.createElement("div", { className: "profile_pic" },
                            react_1.default.createElement(gatsby_plugin_image_1.GatsbyImage, { image: contributor.image.childImageSharp.gatsbyImageData, alt: contributor.name }))),
                    react_1.default.createElement("div", { className: "user-body" },
                        react_1.default.createElement("div", { className: "d-lfex justify-content-center flex-column" },
                            react_1.default.createElement("div", { className: "name_container" },
                                react_1.default.createElement("div", { className: "name" }, contributor.name)),
                            react_1.default.createElement("div", { className: "description_container" },
                                react_1.default.createElement("div", { className: "description" }, contributor.description))),
                        react_1.default.createElement("div", { className: "follow" },
                            react_1.default.createElement("a", { href: `https://twitter.com/${contributor.twitter.substr(1)}`, target: "_blank", rel: "noopener noreferrer", className: "btn btn-social btn-twitter" },
                                react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_brands_svg_icons_1.faTwitter }),
                                " ",
                                contributor.twitter)))))),
        react_1.default.createElement("div", { className: "row" },
            react_1.default.createElement("div", { className: "col-sm-6 offset-sm-3" },
                react_1.default.createElement("h3", { className: "page-header" }, "Blog articles"),
                articles.edges.map((item, i) => (react_1.default.createElement("div", { className: "row mb-3", key: i },
                    react_1.default.createElement("div", { className: "col-md-12" },
                        react_1.default.createElement(articleItem_1.default, { article: item.node })))))))));
};
exports.default = Contributor;
