"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const routes_1 = require("../../routes");
const gatsby_1 = require("gatsby");
const free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const Tags = ({ tags }) => {
    const orderedTags = Object.keys(tags).sort((tag1, tag2) => {
        return tags[tag2] - tags[tag1];
    });
    return (react_1.default.createElement("section", { className: "section container-fluid" },
        react_1.default.createElement("h3", null, "All tags"),
        react_1.default.createElement("div", { className: "row" },
            react_1.default.createElement("div", { className: "col-sm-6 offset-sm-3" },
                react_1.default.createElement("p", null,
                    orderedTags.length,
                    " tags"),
                react_1.default.createElement("p", null, orderedTags.map((tag) => (react_1.default.createElement(gatsby_1.Link, { to: (0, routes_1.pathTo)('tag', { tag: tag }), key: tag, className: "btn btn-primary mr-2" },
                    react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faTag }),
                    " ",
                    tag,
                    " (",
                    tags[tag],
                    ")"))))))));
};
exports.default = Tags;
