"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const gatsby_1 = require("gatsby");
const Changelog = () => {
    return (react_1.default.createElement("section", { className: "section container-fluid" },
        react_1.default.createElement("div", { className: "row" },
            react_1.default.createElement("div", { className: "col-md-12" },
                react_1.default.createElement("h3", null, "Changelog"),
                react_1.default.createElement("ul", { className: "timeline" },
                    react_1.default.createElement(gatsby_1.StaticQuery, { query: (0, gatsby_1.graphql) `
                query ChangelogQuery {
                  allChangelogYaml {
                    edges {
                      node {
                        date(formatString: "MMMM Do YYYY")
                        label
                        tag
                      }
                    }
                  }
                }
              `, render: (data) => {
                            const items = data.allChangelogYaml.edges;
                            return items.map((item, index) => (react_1.default.createElement("li", { key: index },
                                react_1.default.createElement("a", { href: items[index + 1]
                                        ? `https://github.com/uniflow-io/uniflow/compare/${items[index + 1].node.tag}...${items[index].node.tag}`
                                        : `https://github.com/uniflow-io/uniflow/releases/tag/${item.node.tag}`, target: "_blank", rel: "noopener noreferrer" }, item.node.tag),
                                react_1.default.createElement("span", { className: "float-end" }, item.node.date),
                                react_1.default.createElement("p", null, item.node.label.split('\n').map((item, key) => {
                                    return (react_1.default.createElement("span", { key: key },
                                        item,
                                        react_1.default.createElement("br", null)));
                                })),
                                react_1.default.createElement("hr", null))));
                        } }))))));
};
exports.default = Changelog;
