"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const gatsby_1 = require("gatsby");
const react_1 = __importDefault(require("react"));
const api_exceptions_1 = require("../models/api-exceptions");
const routes_1 = require("../routes");
const react_2 = require("react");
const services_1 = require("../services");
const container_1 = __importDefault(require("../container"));
const form_input_1 = __importStar(require("../components/form-input"));
const alert_1 = __importStar(require("../components/alert"));
const container = new container_1.default();
const api = container.get(services_1.Api);
const Contact = () => {
    const [email, setEmail] = (0, react_2.useState)('');
    const [message, setMessage] = (0, react_2.useState)('');
    const [errors, setErrors] = (0, react_2.useState)({});
    const [state, setState] = (0, react_2.useState)('form');
    const onSubmit = async (event) => {
        event.preventDefault();
        setState('form-submit');
        try {
            const data = await api.contact({ email, message });
            if (data === true) {
                setState('form-success');
            }
        }
        catch (error) {
            setState('form');
            if (error instanceof api_exceptions_1.ApiValidateException) {
                setErrors({ ...error.errors });
            }
            else if (error instanceof Error) {
                setErrors({ form: [error.message] });
            }
        }
    };
    return (react_1.default.createElement("section", { className: "section container-fluid" },
        react_1.default.createElement("div", { className: "row" },
            react_1.default.createElement("div", { className: "col-md-12" },
                react_1.default.createElement("h3", null, "Contact"),
                state === 'form-success' && (react_1.default.createElement(alert_1.default, { type: alert_1.AlertType.SUCCESS },
                    "Your message has been sent, we will glad to ear from you !",
                    react_1.default.createElement("br", null),
                    "In case check ",
                    react_1.default.createElement(gatsby_1.Link, { to: (0, routes_1.pathTo)('doc', { slug: 'faq' }) }, "FAQ"),
                    " page to see if your question has been answered already.")),
                (state === 'form' || state === 'form-submit') && [
                    react_1.default.createElement("p", { className: "text-center", key: "say" }, "You got a question about Uniflow? Write more here."),
                    react_1.default.createElement("form", { key: "contactForm", onSubmit: onSubmit },
                        errors.form &&
                            errors.form.map((message, i) => (react_1.default.createElement(alert_1.default, { key: i, type: alert_1.AlertType.DANGER }, message))),
                        react_1.default.createElement(form_input_1.default, { type: form_input_1.FormInputType.TEXT, id: "contact-email", placeholder: "Email", value: email, errors: errors.email, onChange: setEmail }),
                        react_1.default.createElement(form_input_1.default, { type: form_input_1.FormInputType.TEXTAREA, id: "contact-message", placeholder: "Message", value: message, errors: errors.message, onChange: setMessage, rows: 15 }),
                        react_1.default.createElement("div", { className: "row mb-3" },
                            react_1.default.createElement("div", { className: "col-md-12" },
                                react_1.default.createElement("div", { className: "d-grid" },
                                    react_1.default.createElement("button", { type: "submit", className: "btn btn-primary", disabled: state === 'form-submit' }, "Send"))))),
                ]))));
};
exports.default = Contact;
