"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const gatsby_1 = require("gatsby");
const gatsby_plugin_mdx_1 = require("gatsby-plugin-mdx");
const free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const navigation_1 = __importDefault(require("./navigation"));
const free_regular_svg_icons_1 = require("@fortawesome/free-regular-svg-icons");
const routes_1 = require("../../routes");
const components_1 = require("../../components");
const Doc = (props) => {
    const { doc, docNav, previous, next } = props;
    return (react_1.default.createElement("div", { className: "container-fluid" },
        react_1.default.createElement("div", { className: "row flex-sm-nowrap" },
            react_1.default.createElement(navigation_1.default, { docNav: docNav, slug: doc.fields.slug }),
            react_1.default.createElement("section", { className: "section section-with-sidebar col" },
                react_1.default.createElement("h3", { className: "mb-3" }, doc.frontmatter.title),
                react_1.default.createElement("div", { className: "row mb-3" },
                    react_1.default.createElement("div", { className: "col-sm-12" },
                        react_1.default.createElement(components_1.MDXProvider, null,
                            react_1.default.createElement(gatsby_plugin_mdx_1.MDXRenderer, null, doc.body)),
                        react_1.default.createElement("p", null,
                            react_1.default.createElement("a", { href: `https://github.com/uniflow-io/uniflow/blob/1.x/docs/docs/${doc.parent.relativePath}`, target: "_blank", rel: "noopener noreferrer" },
                                react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_regular_svg_icons_1.faEdit }),
                                " Edit this page on GitHub")))),
                react_1.default.createElement("div", { className: "row" },
                    react_1.default.createElement("div", { className: "col-auto" }, previous && (react_1.default.createElement(gatsby_1.Link, { to: (0, routes_1.pathTo)('doc', previous.fields.slug ? { slug: previous.fields.slug } : {}), className: "pull-left" },
                        react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faArrowLeft }),
                        " ",
                        previous.frontmatter.title))),
                    react_1.default.createElement("div", { className: "col-auto ms-auto" }, next && (react_1.default.createElement(gatsby_1.Link, { to: (0, routes_1.pathTo)('doc', next.fields.slug ? { slug: next.fields.slug } : {}), className: "pull-right" },
                        next.frontmatter.title,
                        " ",
                        react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faArrowRight })))))))));
};
exports.default = Doc;
