"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const gatsby_1 = require("gatsby");
const routes_1 = require("../../routes");
const Navigation = (props) => {
    const [search, setSearch] = (0, react_1.useState)('');
    const [isCollapsed, setIsCollapsed] = (0, react_1.useState)(true);
    const onSearch = (event) => {
        setSearch(event.target.value);
    };
    const onToggle = (event) => {
        setIsCollapsed(!isCollapsed);
    };
    const onSubmit = (event) => {
        event.preventDefault();
    };
    const itemPathTo = (item) => {
        const slug = item.link.slice(6);
        return (0, routes_1.pathTo)('doc', { slug: slug ? slug : null });
    };
    const isActive = (item, slug) => {
        return item.link === `/docs${slug ? '/' + slug : ''}` ? 'active' : undefined;
    };
    const filterNav = (nav, search) => {
        return nav.reduce((value, group) => {
            const items = group.items.filter((item) => {
                let words = item.title;
                words = words.toLowerCase();
                return words.indexOf(search) !== -1;
            });
            if (items.length > 0) {
                value.push({
                    ...group,
                    items: items,
                });
            }
            return value;
        }, []);
    };
    const { docNav, slug } = props;
    return (react_1.default.createElement("div", { className: "sidebar" },
        react_1.default.createElement("form", { className: "sidebar-search d-flex align-items-center", role: "search", onSubmit: onSubmit },
            react_1.default.createElement("div", { className: "input-group" },
                react_1.default.createElement("input", { type: "search", className: "form-control ds-input", placeholder: "Search...", "aria-label": "Search for...", value: search, onChange: onSearch })),
            react_1.default.createElement("button", { className: "btn d-sm-none py-0 px-0 ms-3 isCollapsedd", type: "button", onClick: onToggle }, (isCollapsed && (react_1.default.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "24", height: "24", className: "bi bi-expand", fill: "currentColor", viewBox: "0 0 16 16" },
                react_1.default.createElement("title", null, "Expand"),
                react_1.default.createElement("use", { xlinkHref: "#nav-expand" })))) || (react_1.default.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "24", height: "24", className: "bi bi-expand", fill: "currentColor", viewBox: "0 0 16 16" },
                react_1.default.createElement("title", null, "Collapse"),
                react_1.default.createElement("use", { xlinkHref: "#nav-collapse" }))))),
        react_1.default.createElement("nav", { className: `sidebar-nav${isCollapsed ? ' d-none d-sm-block' : ''}` },
            react_1.default.createElement("div", { className: "sidebar-section" }, filterNav(docNav.nodes, search).map((section, sectionIndex) => (react_1.default.createElement(react_1.default.Fragment, { key: `section-${sectionIndex}` },
                react_1.default.createElement("h4", null, section.title),
                react_1.default.createElement("ul", { className: "sidebar-items" }, section.items.map((item, itemIndex) => (react_1.default.createElement("li", { className: isActive(item, slug), key: `item-${sectionIndex}-${itemIndex}` },
                    react_1.default.createElement("span", { className: "link" }, item.title),
                    react_1.default.createElement(gatsby_1.Link, { to: itemPathTo(item) }, item.title))))))))))));
};
exports.default = Navigation;
