"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const gatsby_1 = require("gatsby");
const debounce_1 = __importDefault(require("lodash/debounce"));
const free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const router_1 = require("@reach/router");
const feed_1 = require("../../contexts/feed");
const components_1 = require("../../components");
const react_2 = require("react");
const contexts_1 = require("../../contexts");
const api_exceptions_1 = require("../../models/api-exceptions");
const form_input_1 = __importStar(require("../../components/form-input"));
const alert_1 = __importStar(require("../../components/alert"));
const Folder = (props) => {
    const [folderTreeEdit, setFolderTreeEdit] = (0, react_1.useState)(false);
    const [folderTree, setFolderTree] = (0, react_1.useState)([]);
    const [errors, setErrors] = (0, react_1.useState)({});
    const { user, userDispatch } = (0, contexts_1.useUser)();
    const { auth, authDispatch } = (0, contexts_1.useAuth)();
    const { feed, feedDispatch, feedRef } = (0, feed_1.useFeed)();
    const { folder } = props;
    const location = (0, router_1.useLocation)();
    (0, react_2.useEffect)(() => {
        setFolderTreeEdit(false);
        setFolderTree([props.folder.path]);
        return () => {
            onUpdate.cancel();
        };
    }, [props.folder.uid]);
    const onUpdate = (0, react_1.useMemo)(() => (0, debounce_1.default)(async () => {
        if (feedRef.current.parentFolder && auth.token) {
            try {
                setErrors({});
                await (0, feed_1.updateParentFolder)(feedRef.current.parentFolder, auth.token)(feedDispatch, userDispatch, authDispatch);
                const path = (0, feed_1.toFeedPath)(feedRef.current.parentFolder, user);
                if (feedRef.current.parentFolder.slug && path !== location.pathname) {
                    (0, gatsby_1.navigate)(path);
                }
            }
            catch (error) {
                if (error instanceof api_exceptions_1.ApiValidateException) {
                    setErrors({ ...error.errors });
                }
            }
        }
    }, 1000), [props.folder.uid]);
    const onDelete = async (event) => {
        event.preventDefault();
        if (auth.token) {
            await (0, feed_1.deleteParentFolder)(folder, auth.token)(feedDispatch, userDispatch, authDispatch);
            (0, gatsby_1.navigate)((0, feed_1.toFeedPath)(folder, user, true));
        }
    };
    const onChangeName = (name) => {
        (0, feed_1.commitSetParentFolderFeed)({
            ...folder,
            ...{ name },
        })(feedDispatch);
        onUpdate();
    };
    const onChangeSlug = (slug) => {
        (0, feed_1.commitSetParentFolderFeed)({
            ...folder,
            ...{ slug },
        })(feedDispatch);
        onUpdate();
    };
    const onChangePath = async (selected) => {
        (0, feed_1.commitSetParentFolderFeed)({
            ...folder,
            ...{ path: selected },
        })(feedDispatch);
        onUpdate();
    };
    const onFolderEdit = async (event) => {
        event.preventDefault();
        if (feed.uid) {
            let folderTree = await (0, feed_1.getFolderTree)(feed.uid, auth.token)(feedDispatch, userDispatch, authDispatch) || [];
            folderTree = folderTree.filter((value) => {
                return value.indexOf(`${folder.path === '/' ? '' : folder.path}/${folder.slug}`) !== 0;
            });
            setFolderTreeEdit(true);
            setFolderTree(folderTree);
        }
    };
    return (react_1.default.createElement("section", { className: "section section-with-sidebar col" },
        react_1.default.createElement("div", { className: "row" },
            react_1.default.createElement("div", { className: "col" },
                react_1.default.createElement("h3", null, "Infos")),
            react_1.default.createElement("div", { className: "d-block col-auto" },
                react_1.default.createElement("div", { className: "btn-toolbar", role: "toolbar", "aria-label": "folder actions" },
                    react_1.default.createElement("div", { className: "btn-group-sm", role: "group" },
                        react_1.default.createElement("button", { type: "button", className: "btn", onClick: onDelete },
                            react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faTimes })))))),
        react_1.default.createElement("form", { className: "form-sm-horizontal" },
            errors.form &&
                errors.form.map((message, i) => (react_1.default.createElement(alert_1.default, { key: i, type: alert_1.AlertType.DANGER }, message))),
            react_1.default.createElement(form_input_1.default, { id: "folder-name", type: form_input_1.FormInputType.TEXT, label: "Name", value: folder.name, errors: errors.name, onChange: onChangeName }),
            react_1.default.createElement(form_input_1.default, { id: "folder-slug", type: form_input_1.FormInputType.TEXT, label: "Slug", value: folder.slug, errors: errors.slug, onChange: onChangeSlug }),
            react_1.default.createElement("div", { className: "row mb-3" },
                react_1.default.createElement("label", { htmlFor: "folder-path", className: "col-sm-2 col-form-label" }, "Path"),
                react_1.default.createElement("div", { className: "col-sm-10" },
                    (folderTreeEdit && (react_1.default.createElement(components_1.Select, { value: folder.path, onChange: onChangePath, className: "form-control", id: "folder-path", options: folderTree.map((value) => {
                            return { value: value, label: value };
                        }) }))) || (react_1.default.createElement("span", null,
                        react_1.default.createElement("button", { type: "button", className: "btn btn-secondary", onClick: onFolderEdit },
                            react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faEdit })),
                        ' ',
                        folder.path)),
                    errors.path &&
                        errors.path.map((message, i) => (react_1.default.createElement("div", { key: `error-${i}`, className: "invalid-feedback" }, message))))))));
};
exports.default = Folder;
