"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const gatsby_1 = require("gatsby");
const remarkable_1 = require("remarkable");
const feed_1 = require("../contexts/feed");
const contexts_1 = require("../contexts");
const react_2 = require("react");
const react_3 = require("react");
const container_1 = __importDefault(require("../container"));
const services_1 = require("../services");
const container = new container_1.default();
const api = container.get(services_1.Api);
const Flows = () => {
    const [page, setPage] = (0, react_2.useState)(1);
    const [programs, setPrograms] = (0, react_2.useState)([]);
    const [state, setState] = (0, react_2.useState)('loaded');
    const { user } = (0, contexts_1.useUser)();
    const md = new remarkable_1.Remarkable();
    const onFetchPrograms = async () => {
        setState('loading');
        const programsPagination = (0, feed_1.apiToPaginatedProgramFeedEntity)(await api.getPrograms({ page }));
        const fetchPrograms = programs.slice().concat(programsPagination.data);
        setPage(page + 1);
        setPrograms(fetchPrograms);
        setState(fetchPrograms.length < programsPagination.total ? 'load-more' : 'loaded');
    };
    (0, react_3.useEffect)(() => {
        onFetchPrograms();
    }, []);
    return (react_1.default.createElement("section", { className: "section container-fluid" },
        react_1.default.createElement("div", { className: "row" },
            react_1.default.createElement("div", { className: "col-md-12" },
                react_1.default.createElement("h3", null, "Flows"),
                react_1.default.createElement("dl", { className: "row" }, programs.map((program, i) => [
                    react_1.default.createElement("dt", { className: "col-md-2 text-md-end fw-normal", key: i * 2 },
                        react_1.default.createElement(gatsby_1.Link, { to: (0, feed_1.toFeedPath)(program, user) }, program.name)),
                    react_1.default.createElement("dd", { className: "col-md-10", key: i * 2 + 1, dangerouslySetInnerHTML: { __html: md.render(program.description || '') } }),
                ])),
                (state === 'loading' || state === 'load-more') && (react_1.default.createElement("div", { className: "row" },
                    react_1.default.createElement("div", { className: "col-md-12" },
                        react_1.default.createElement("div", { className: "d-grid" },
                            state === 'load-more' && (react_1.default.createElement("button", { className: "btn btn-primary", onClick: onFetchPrograms }, "Load more")),
                            state === 'loading' && (react_1.default.createElement("button", { className: "btn btn-primary", type: "button", disabled: true },
                                react_1.default.createElement("span", { className: "spinner-border spinner-border-sm", role: "status", "aria-hidden": "true" }),
                                "Loading..."))))))))));
};
exports.default = Flows;
