"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const gatsby_1 = require("gatsby");
const api_exceptions_1 = require("../models/api-exceptions");
const routes_1 = require("../routes");
const services_1 = require("../services");
const container_1 = __importDefault(require("../container"));
const alert_1 = __importStar(require("../components/alert"));
const container = new container_1.default();
const api = container.get(services_1.Api);
const Home = () => {
    const [email, setEmail] = (0, react_1.useState)('');
    const [errors, setErrors] = (0, react_1.useState)({});
    const [state, setState] = (0, react_1.useState)('form');
    const onChangeEmail = (event) => {
        setEmail(event.target.value);
    };
    const onSubmit = async (event) => {
        event.preventDefault();
        setState('form-submit');
        try {
            const data = await api.createLead({
                email,
                optinNewsletter: true,
                optinBlog: true,
            });
            if (data) {
                setState('form-success');
            }
        }
        catch (error) {
            if (error instanceof api_exceptions_1.ApiValidateException) {
                setErrors({ ...error.errors });
                setState('form');
            }
        }
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("section", { className: "section container vh-100" },
            react_1.default.createElement("div", { className: "row h-100 align-items-center" },
                react_1.default.createElement("div", { className: "col-md-12 text-center" },
                    react_1.default.createElement("h1", null, "Unified Workflow Automation Tool"),
                    react_1.default.createElement("p", null, "Automate your recurring tasks once, run it everywhere."),
                    react_1.default.createElement("div", { id: "newsletter-optin", className: "d-flex justify-content-center pt-md-5" },
                        state === 'form-success' && (react_1.default.createElement(alert_1.default, { type: alert_1.AlertType.SUCCESS },
                            email,
                            " was succefully registered to the newsletter.",
                            react_1.default.createElement("br", null),
                            "Let's check",
                            ' ',
                            react_1.default.createElement(gatsby_1.Link, { to: (0, routes_1.pathTo)('tag', { tag: 'case-study' }) }, "some cases studies"),
                            " to get started.")),
                        (state === 'form' || state === 'form-submit') && (react_1.default.createElement("form", { onSubmit: onSubmit },
                            react_1.default.createElement("div", { className: `input-group input-group-lg${errors.email ? ' is-invalid' : ''}` },
                                react_1.default.createElement("input", { className: `form-control${errors.email ? ' is-invalid' : ''}`, id: "newsletter-email", type: "text", value: email || '', onChange: onChangeEmail, placeholder: "Email" }),
                                react_1.default.createElement("button", { type: "submit", className: "btn btn-primary input-group-text", disabled: state === 'form-submit' }, "Subscribe to the newsletter"),
                                errors.email &&
                                    errors.email.map((message, i) => (react_1.default.createElement("div", { key: `error-${i}`, className: "invalid-feedback" }, message)))))))))),
        react_1.default.createElement("section", { className: "section container" },
            react_1.default.createElement("div", { className: "row py-5" },
                react_1.default.createElement("div", { className: "col-lg-12 text-center" },
                    react_1.default.createElement("h2", null, "Features"))),
            react_1.default.createElement("div", { className: "row" },
                react_1.default.createElement("div", { className: "col-lg-4 py-md-5" },
                    react_1.default.createElement("h3", null, "Note taking philosophy"),
                    react_1.default.createElement("p", null, "Create your Flows as you take note.")),
                react_1.default.createElement("div", { className: "col-lg-4 py-md-5" },
                    react_1.default.createElement("h3", null, "Modulable"),
                    react_1.default.createElement("p", null, "Create your own specific Flows.")),
                react_1.default.createElement("div", { className: "col-lg-4 py-md-5" },
                    react_1.default.createElement("h3", null, "Multiple clients"),
                    react_1.default.createElement("p", null, "Run your Flows on dedicated Clients.")),
                react_1.default.createElement("div", { className: "col-lg-4 py-md-5" },
                    react_1.default.createElement("h3", null, "Open"),
                    react_1.default.createElement("p", null, "Uniflow is fair-code licensed.")),
                react_1.default.createElement("div", { className: "col-lg-4 py-md-5" },
                    react_1.default.createElement("h3", null, "Control your data"),
                    react_1.default.createElement("p", null, "Install and run Uniflow locally.")),
                react_1.default.createElement("div", { className: "col-lg-4 py-md-5" },
                    react_1.default.createElement("h3", null, "Community"),
                    react_1.default.createElement("p", null, "Get inspiration from community."))))));
};
exports.default = Home;
