"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const gatsby_plugin_mdx_1 = require("gatsby-plugin-mdx");
const gatsby_plugin_image_1 = require("gatsby-plugin-image");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const free_brands_svg_icons_1 = require("@fortawesome/free-brands-svg-icons");
const free_regular_svg_icons_1 = require("@fortawesome/free-regular-svg-icons");
const navigation_1 = __importDefault(require("./navigation"));
const components_1 = require("../../components");
const Card = (props) => {
    const { library, card, logo } = props;
    let repository = card.repository.url;
    let editUrl = null;
    if (card.official) {
        repository = `https://github.com/uniflow-io/uniflow/tree/1.x/${card.repository.directory}`;
        editUrl = `https://github.com/uniflow-io/uniflow/blob/1.x/${card.repository.directory}/README.md`;
    }
    return (react_1.default.createElement("div", { className: "container-fluid" },
        react_1.default.createElement("div", { className: "row flex-sm-nowrap" },
            react_1.default.createElement(navigation_1.default, { library: library, slug: card.fields.slug }),
            react_1.default.createElement("section", { className: "section section-with-sidebar col" },
                react_1.default.createElement("div", { className: "row mb-3" },
                    react_1.default.createElement("div", { className: "col-sm-12" },
                        react_1.default.createElement("div", { className: "row text-secondary" },
                            react_1.default.createElement("div", { className: "col-auto" },
                                react_1.default.createElement("p", null,
                                    react_1.default.createElement("a", { href: repository, target: "_blank", rel: "noopener noreferrer" },
                                        react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_brands_svg_icons_1.faGithub }),
                                        " View on GitHub"))),
                            react_1.default.createElement("div", { className: "col-auto" }, card.fields.catalogs.map((catalog, j) => (react_1.default.createElement("span", { key: j, className: "badge badge-light mr-1" }, catalog)))),
                            card.official && (react_1.default.createElement("div", { className: "col-auto ms-auto" },
                                react_1.default.createElement("span", null,
                                    react_1.default.createElement(gatsby_plugin_image_1.GatsbyImage, { image: logo.childImageSharp.gatsbyImageData, className: "svg-inline--fa", alt: "Uniflow" }),
                                    ' ',
                                    "Official")))),
                        react_1.default.createElement(components_1.MDXProvider, null,
                            react_1.default.createElement(gatsby_plugin_mdx_1.MDXRenderer, null, card.readme.childMdx.body)),
                        editUrl && (react_1.default.createElement("p", null,
                            react_1.default.createElement("a", { href: editUrl, target: "_blank", rel: "noopener noreferrer" },
                                react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_regular_svg_icons_1.faEdit }),
                                " Edit this page on GitHub")))))))));
};
exports.default = Card;
