"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const gatsby_1 = require("gatsby");
const routes_1 = require("../../routes");
const Navigation = (props) => {
    const [search, setSearch] = (0, react_1.useState)('');
    const [isCollapsed, setIsCollapsed] = (0, react_1.useState)(true);
    const onSearch = (event) => {
        setSearch(event.target.value);
    };
    const onToggle = (event) => {
        setIsCollapsed(!isCollapsed);
    };
    const onSubmit = (event) => {
        event.preventDefault();
    };
    const itemPathTo = (card) => {
        return (0, routes_1.pathTo)('card', { slug: card.fields.slug });
    };
    const isActive = (card, slug) => {
        return card.fields.slug === slug ? 'active' : undefined;
    };
    const filterNav = (library, search) => {
        return library.reduce((cardList, card) => {
            let words = card.name;
            words += ' ' + card.description;
            for (let i = 0; i < card.fields.catalogs.length; i++) {
                words += ' ' + card.fields.catalogs[i];
            }
            words = words.toLowerCase();
            if (words.indexOf(search) !== -1) {
                cardList.push(card);
            }
            return cardList;
        }, []);
    };
    const { library, slug } = props;
    return (react_1.default.createElement("div", { className: "sidebar" },
        react_1.default.createElement("form", { className: "sidebar-search d-flex align-items-center", role: "search", onSubmit: onSubmit },
            react_1.default.createElement("div", { className: "input-group" },
                react_1.default.createElement("input", { type: "search", className: "form-control ds-input", placeholder: "Search...", "aria-label": "Search for...", value: search, onChange: onSearch })),
            react_1.default.createElement("button", { className: "btn d-sm-none py-0 px-0 ms-3 isCollapsedd", type: "button", onClick: onToggle }, (isCollapsed && (react_1.default.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "24", height: "24", className: "bi bi-expand", fill: "currentColor", viewBox: "0 0 16 16" },
                react_1.default.createElement("title", null, "Expand"),
                react_1.default.createElement("use", { xlinkHref: "#nav-expand" })))) || (react_1.default.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "24", height: "24", className: "bi bi-expand", fill: "currentColor", viewBox: "0 0 16 16" },
                react_1.default.createElement("title", null, "Collapse"),
                react_1.default.createElement("use", { xlinkHref: "#nav-collapse" }))))),
        react_1.default.createElement("nav", { className: `sidebar-nav${isCollapsed ? ' d-none d-sm-block' : ''}` },
            react_1.default.createElement("div", { className: "sidebar-section" },
                react_1.default.createElement("ul", { className: "sidebar-items" }, filterNav(library, search).map((card, cardIndex) => (react_1.default.createElement("li", { className: isActive(card, slug), key: `card-${cardIndex}` },
                    react_1.default.createElement("span", { className: "link" },
                        card.name,
                        ' ',
                        card.fields.catalogs.map((catalog, j) => (react_1.default.createElement("span", { key: j, className: "badge badge-light mr-1" }, catalog)))),
                    react_1.default.createElement("span", null, card.description),
                    react_1.default.createElement(gatsby_1.Link, { to: itemPathTo(card) }, card.name)))))))));
};
exports.default = Navigation;
