"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const gatsby_1 = require("gatsby");
const routes_1 = require("../../routes");
const auth_1 = require("../../contexts/auth");
const logs_1 = require("../../contexts/logs");
const contexts_1 = require("../../contexts");
const router_1 = require("@reach/router");
const GithubLogin = (props) => {
    const { authDispatch, authRef } = (0, contexts_1.useAuth)();
    const { logsDispatch } = (0, contexts_1.useLogs)();
    const location = (0, router_1.useLocation)();
    const getCode = () => {
        const m = location.search.match(/code=([^&]+)/);
        if (m) {
            return m[1];
        }
        return null;
    };
    (0, react_1.useEffect)(() => {
        (async () => {
            const code = getCode();
            if (code === null) {
                return (0, gatsby_1.navigate)((0, routes_1.pathTo)('login'));
            }
            await (0, auth_1.githubLogin)(code, authRef.current.token)(authDispatch);
            if (authRef.current.isAuthenticated) {
                (0, gatsby_1.navigate)((0, routes_1.pathTo)('feed'));
            }
            else if (authRef.current.message) {
                (0, logs_1.commitAddLog)(authRef.current.message)(logsDispatch);
                (0, gatsby_1.navigate)((0, routes_1.pathTo)('login'));
            }
        })();
    }, []);
    return (react_1.default.createElement("section", { className: "section container-fluid" },
        react_1.default.createElement("h3", { className: "box-title" }, "Login Github"),
        react_1.default.createElement("p", { className: "text-center" }, "Application is currently logging you from Github")));
};
exports.default = GithubLogin;
