"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const auth_1 = require("../../contexts/auth");
const routes_1 = require("../../routes");
const gatsby_1 = require("gatsby");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
const free_brands_svg_icons_1 = require("@fortawesome/free-brands-svg-icons");
const container_1 = __importDefault(require("../../container"));
const services_1 = require("../../services");
const contexts_1 = require("../../contexts");
const api_exceptions_1 = require("../../models/api-exceptions");
const alert_1 = __importStar(require("../../components/alert"));
const form_input_1 = __importStar(require("../../components/form-input"));
const container = new container_1.default();
const env = container.get(services_1.Env);
const Register = () => {
    const [email, setEmail] = (0, react_1.useState)('');
    const [password, setPassword] = (0, react_1.useState)('');
    const [errors, setErrors] = (0, react_1.useState)({});
    const { auth, authDispatch, authRef } = (0, contexts_1.useAuth)();
    const { logsDispatch } = (0, contexts_1.useLogs)();
    const onSubmit = async (event) => {
        event.preventDefault();
        try {
            await (0, auth_1.register)(email, password)(authDispatch);
            if (authRef.current.isAuthenticated) {
                (0, gatsby_1.navigate)((0, routes_1.pathTo)('feed'));
            }
        }
        catch (error) {
            if (error instanceof api_exceptions_1.ApiValidateException) {
                setErrors({ ...error.errors });
            }
            else if (authRef.current.message) {
                setErrors({ form: [authRef.current.message] });
            }
        }
    };
    const facebookAppId = env.get('facebookAppId');
    const githubAppId = env.get('githubAppId');
    return (react_1.default.createElement("section", { className: "section container-fluid" },
        react_1.default.createElement("h3", null, "Register"),
        react_1.default.createElement("div", { className: "row" },
            react_1.default.createElement("div", { className: "col-sm-6 offset-sm-3" },
                react_1.default.createElement("div", { className: "card" },
                    react_1.default.createElement("article", { className: "card-body" },
                        react_1.default.createElement("form", { onSubmit: onSubmit },
                            errors.form &&
                                errors.form.map((message, i) => (react_1.default.createElement(alert_1.default, { key: i, type: alert_1.AlertType.DANGER }, message))),
                            react_1.default.createElement(form_input_1.default, { id: "register-email", type: form_input_1.FormInputType.TEXT, placeholder: "Email", value: email, errors: errors.email, icon: free_solid_svg_icons_1.faUser, onChange: setEmail, autoComplete: true }),
                            react_1.default.createElement(form_input_1.default, { id: "register-password", type: form_input_1.FormInputType.PASSWORD, placeholder: "Password", value: password, errors: errors.password, icon: free_solid_svg_icons_1.faKey, onChange: setPassword, autoComplete: true }),
                            react_1.default.createElement("div", { className: "row mb-3" },
                                react_1.default.createElement("div", { className: "col-md-12" },
                                    react_1.default.createElement("div", { className: "d-grid" },
                                        react_1.default.createElement("button", { type: "submit", className: "btn btn-primary", disabled: auth.isAuthenticating }, "Register"))))),
                        facebookAppId && (react_1.default.createElement("div", { className: "row mb-3" },
                            react_1.default.createElement("div", { className: "col-md-12" },
                                react_1.default.createElement("div", { className: "d-grid" },
                                    react_1.default.createElement("a", { href: (0, auth_1.facebookLoginUrl)(facebookAppId), className: "btn btn-social btn-facebook" },
                                        react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_brands_svg_icons_1.faFacebookF }),
                                        " Register with Facebook"))))),
                        githubAppId && (react_1.default.createElement("div", { className: "row" },
                            react_1.default.createElement("div", { className: "col-md-12" },
                                react_1.default.createElement("div", { className: "d-grid" },
                                    react_1.default.createElement("a", { href: (0, auth_1.githubLoginUrl)(githubAppId), className: "btn btn-social btn-github" },
                                        react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_brands_svg_icons_1.faGithub }),
                                        " Register with Github")))))))))));
};
exports.default = Register;
