"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const gatsby_plugin_mdx_1 = require("gatsby-plugin-mdx");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const free_regular_svg_icons_1 = require("@fortawesome/free-regular-svg-icons");
const components_1 = require("../components");
const Newsletter = (props) => {
    const { newsletter } = props;
    return (react_1.default.createElement("div", { className: "container-fluid" },
        react_1.default.createElement("div", { className: "row" },
            react_1.default.createElement("section", { className: "section col" },
                react_1.default.createElement("h3", { className: "mb-3" }, newsletter.frontmatter.title),
                react_1.default.createElement("div", { className: "row mb-3" },
                    react_1.default.createElement("div", { className: "col-sm-12" },
                        react_1.default.createElement(components_1.MDXProvider, null,
                            react_1.default.createElement(gatsby_plugin_mdx_1.MDXRenderer, null, newsletter.body)),
                        react_1.default.createElement("p", null,
                            react_1.default.createElement("a", { href: `https://github.com/uniflow-io/uniflow/blob/1.x/docs/newsletters/${newsletter.parent.relativePath}`, target: "_blank", rel: "noopener noreferrer" },
                                react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_regular_svg_icons_1.faEdit }),
                                " Edit this page on GitHub"))))))));
};
exports.default = Newsletter;
