"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_2 = require("react");
const api_exceptions_1 = require("../models/api-exceptions");
const routes_1 = require("../routes");
const router_1 = require("@reach/router");
const services_1 = require("../services");
const container_1 = __importDefault(require("../container"));
const alert_1 = __importStar(require("../components/alert"));
const form_input_1 = __importStar(require("../components/form-input"));
const container = new container_1.default();
const api = container.get(services_1.Api);
const Notifications = () => {
    const [lead, setLead] = (0, react_2.useState)({
        uid: undefined,
        optinNewsletter: false,
        optinBlog: false,
        optinGithub: false,
        githubUsername: null,
    });
    const [errors, setErrors] = (0, react_2.useState)({});
    const [state, setState] = (0, react_2.useState)('loading');
    const location = (0, router_1.useLocation)();
    (0, react_1.useEffect)(() => {
        const uid = getId();
        (async () => {
            const match = (0, routes_1.matchRoute)(location.pathname);
            if (uid !== null && match) {
                if (match.route === 'notificationUnsubscribe') {
                    try {
                        await api.updateLead({ uid }, {
                            optinNewsletter: false,
                            optinBlog: false,
                            optinGithub: false,
                        });
                        setLead({ ...lead, ...{ uid } });
                        setState('unsubscribe-success');
                    }
                    catch (error) {
                        setState('not-found');
                    }
                }
                else if (match.route === 'notificationManage') {
                    try {
                        const data = await api.getLead({ uid });
                        setLead({
                            ...lead,
                            ...{
                                uid,
                                optinNewsletter: data.optinNewsletter,
                                optinBlog: data.optinBlog,
                                optinGithub: data.optinGithub,
                                githubUsername: data.githubUsername,
                            },
                        });
                        setState('form');
                    }
                    catch (error) {
                        setState('not-found');
                    }
                }
                else {
                    setState('not-found');
                }
            }
            else {
                setState('not-found');
            }
        })();
    }, []);
    const getId = () => {
        const m = location.search.match(/id=([^&]+)/);
        if (m) {
            return m[1];
        }
        return null;
    };
    const onChangeOptinNewsletter = (value) => {
        setLead({ ...lead, ...{ optinNewsletter: value } });
    };
    const onChangeOptinBlog = (value) => {
        setLead({ ...lead, ...{ optinBlog: value } });
    };
    const onChangeOptinGithub = (value) => {
        setLead({ ...lead, ...{ optinGithub: value } });
    };
    const onSubmit = async (event) => {
        event.preventDefault();
        if (!lead.uid) {
            setState('not-found');
            return;
        }
        setState('form-submit');
        try {
            await api.updateLead({ uid: lead.uid }, {
                optinNewsletter: lead.optinNewsletter,
                optinBlog: lead.optinBlog,
                optinGithub: lead.optinGithub,
            });
            setState('form-success');
        }
        catch (error) {
            if (error instanceof api_exceptions_1.ApiValidateException) {
                setErrors({ ...error.errors });
                setState('form');
            }
        }
    };
    return (react_1.default.createElement("section", { className: "section container-fluid" },
        react_1.default.createElement("h3", { className: "box-title" }, "Notifications"),
        state === 'loading' && react_1.default.createElement("p", { className: "text-center" }, "Loading notifications"),
        state === 'not-found' && (react_1.default.createElement(alert_1.default, { type: alert_1.AlertType.DANGER },
            "Notifications coudn't be restored.",
            react_1.default.createElement("br", null),
            "You may check your notification link.")),
        state === 'form-success' && (react_1.default.createElement(alert_1.default, { type: alert_1.AlertType.SUCCESS }, "Your notifications settings have been saved.")),
        state === 'unsubscribe-success' && (react_1.default.createElement(alert_1.default, { type: alert_1.AlertType.SUCCESS }, "Your have been succefully unsubscribed from our emails.")),
        ['form', 'form-submit'].indexOf(state) !== -1 && (react_1.default.createElement("form", { className: "form-sm-horizontal", onSubmit: onSubmit },
            react_1.default.createElement(form_input_1.default, { type: form_input_1.FormInputType.CHECKBOX, id: "notifications-optinNewsletter", label: "Subscribe to the newsletter", value: lead.optinNewsletter, errors: errors.optinNewsletter, onChange: onChangeOptinNewsletter }),
            react_1.default.createElement(form_input_1.default, { type: form_input_1.FormInputType.CHECKBOX, id: "notifications-optinBlog", label: "Subscribe to blog updates", value: lead.optinBlog, errors: errors.optinBlog, onChange: onChangeOptinBlog }),
            lead.githubUsername && (react_1.default.createElement(form_input_1.default, { type: form_input_1.FormInputType.CHECKBOX, id: "notifications-optinGithub", label: "Subscribe to github updates", value: lead.optinGithub, errors: errors.optinGithub, onChange: onChangeOptinGithub })),
            react_1.default.createElement("div", { className: "row mb-3" },
                react_1.default.createElement("div", { className: "offset-sm-2 col-sm-10" },
                    react_1.default.createElement("div", { className: "d-grid" },
                        react_1.default.createElement("button", { type: "submit", className: "btn btn-primary", disabled: state === 'form-submit' }, "Save"))))))));
};
exports.default = Notifications;
