"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const header_1 = __importDefault(require("@uniflow-io/uniflow-client/src/components/flow/header"));
const form_input_1 = __importStar(require("@uniflow-io/uniflow-client/src/components/form-input"));
const flow_1 = require("@uniflow-io/uniflow-client/src/components/flow/flow");
const lz_string_1 = __importDefault(require("lz-string"));
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
const AssetsFlow = (0, flow_1.flow)((props, ref) => {
    const { onPop, onUpdate, onPlay, isPlaying, data, clients } = props;
    (0, react_1.useImperativeHandle)(ref, () => ({
        onSerialize: () => {
            return lz_string_1.default.compressToEncodedURIComponent(JSON.stringify([data?.variable, data?.assets]));
        },
        onDeserialize: (data) => {
            const decompressedData = data ? lz_string_1.default.decompressFromEncodedURIComponent(data) : undefined;
            let [variable, assets] = decompressedData
                ? JSON.parse(decompressedData)
                : [null, []];
            return { variable, assets };
        },
        onCompile: () => {
            if (!data || !data.variable) {
                return '';
            }
            let assets = data?.assets?.reduce(function (data, asset) {
                data[asset[0]] = asset[1];
                return data;
            }, {}) || {};
            return data.variable + ' = ' + JSON.stringify(assets);
        },
        onExecute: async (runner) => {
            if (data?.variable) {
                return runner.run();
            }
        }
    }), [data]);
    const onChangeVariable = (variable) => {
        onUpdate({
            ...data,
            variable
        });
    };
    const onFiles = async (event) => {
        event.persist();
        event.preventDefault();
        let files = [];
        if (event.target.files) {
            for (let i = 0; i < event.target.files.length; i++) {
                files.push(event.target.files[i]);
            }
        }
        return files
            .reduce(async (promise, file) => {
            await promise;
            return await new Promise((resolve, error) => {
                let reader = new FileReader();
                reader.onerror = error;
                reader.onload = e => {
                    let newStateAssets = data?.assets?.slice() || [];
                    newStateAssets.push([file.name, e.target?.result]);
                    onUpdate({
                        ...data,
                        assets: newStateAssets
                    });
                };
                reader.readAsText(file);
            });
        }, Promise.resolve())
            .then(() => {
            event.target.value = '';
        });
    };
    const onDownloadFile = (event, index) => {
        let a = document.createElement('a');
        let blob = new Blob([data?.assets[index][1]], { type: 'octet/stream' });
        let url = window.URL.createObjectURL(blob);
        a.href = url;
        a.download = data?.assets[index][0];
        a.style.cssText = 'display: none';
        document.body.appendChild(a);
        a.click();
        document.body.removeChild(a);
        window.URL.revokeObjectURL(url);
    };
    const onUpdateFile = (event, index) => {
        onUpdate({
            ...data,
            assets: data?.assets?.map((asset, i) => {
                if (i !== index) {
                    return asset;
                }
                return [event.target.value, asset[1]];
            }),
        });
    };
    const onRemoveFile = (event, index) => {
        let newStateAssets = data?.assets?.slice() || [];
        newStateAssets.splice(index, 1);
        onUpdate({ ...data, assets: newStateAssets });
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(header_1.default, { title: "Assets", clients: clients, isPlaying: isPlaying, onPlay: onPlay, onPop: onPop }),
        react_1.default.createElement("form", { className: "form-sm-horizontal" },
            react_1.default.createElement(form_input_1.default, { id: "variable", type: form_input_1.FormInputType.TEXT, label: "Variable", value: data?.variable, onChange: onChangeVariable }),
            data && data.assets?.map((asset, index) => (react_1.default.createElement("div", { key: index, className: "row" },
                react_1.default.createElement("div", { className: "col-sm-10 offset-sm-2" },
                    react_1.default.createElement("div", { className: "input-group" },
                        react_1.default.createElement("button", { type: "button", className: "input-group-text", onClick: event => {
                                onDownloadFile(event, index);
                            } },
                            react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faDownload })),
                        react_1.default.createElement("input", { type: "text", value: asset[0], onChange: event => {
                                onUpdateFile(event, index);
                            }, className: "form-control" }),
                        react_1.default.createElement("button", { type: "button", className: "input-group-text", onClick: event => {
                                onRemoveFile(event, index);
                            } },
                            react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faTimes }))))))),
            react_1.default.createElement("div", { className: "row mb-3" },
                react_1.default.createElement("label", { htmlFor: "assets{{ _uid }}", className: "col-sm-2 col-form-label" }, "Assets"),
                react_1.default.createElement("div", { className: "col-sm-10" },
                    react_1.default.createElement("div", { className: "custom-file" },
                        react_1.default.createElement("input", { id: "assets{{ _uid }}", type: "file", multiple: true, onChange: onFiles, className: "custom-file-input" }),
                        react_1.default.createElement("label", { className: "custom-file-label", htmlFor: "assets{{ _uid }}" }, "Choose file")))))));
});
exports.default = AssetsFlow;
