"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const header_1 = __importDefault(require("@uniflow-io/uniflow-client/src/components/flow/header"));
const form_input_1 = __importStar(require("@uniflow-io/uniflow-client/src/components/form-input"));
const flow_1 = require("@uniflow-io/uniflow-client/src/components/flow/flow");
const react_2 = require("react");
const CanvasFlow = (0, flow_1.flow)((props, ref) => {
    const { onPop, onUpdate, onPlay, isPlaying, data, clients } = props;
    const canvasRef = (0, react_2.useRef)(null);
    (0, react_1.useImperativeHandle)(ref, () => ({
        onSerialize: () => {
            return JSON.stringify([data?.variable, data?.width, data?.height]);
        },
        onDeserialize: (data) => {
            const [variable, width, height] = data ? JSON.parse(data) : [undefined, undefined, undefined];
            return { variable, width: Number(width), height: Number(height) };
        },
        onCompile: () => {
            return '';
        },
        onExecute: async (runner) => {
            let context = runner.getContext();
            if (data?.variable && canvasRef.current) {
                context[data?.variable] = canvasRef.current;
            }
        }
    }), [data]);
    const onChangeVariable = (variable) => {
        onUpdate({
            ...data,
            variable
        });
    };
    const onChangeWidth = (width) => {
        onUpdate({
            ...data,
            width: Number(width)
        });
    };
    const onChangeHeight = (height) => {
        onUpdate({
            ...data,
            height: Number(height)
        });
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(header_1.default, { title: "Canvas", clients: clients, isPlaying: isPlaying, onPlay: onPlay, onPop: onPop }),
        react_1.default.createElement("form", { className: "form-sm-horizontal" },
            react_1.default.createElement(form_input_1.default, { id: "variable", type: form_input_1.FormInputType.TEXT, label: "Variable", value: data?.variable, onChange: onChangeVariable }),
            react_1.default.createElement(form_input_1.default, { id: "width", type: form_input_1.FormInputType.TEXT, label: "Width", value: data?.width, onChange: onChangeWidth }),
            react_1.default.createElement(form_input_1.default, { id: "height", type: form_input_1.FormInputType.TEXT, label: "Height", value: data?.height, onChange: onChangeHeight }),
            react_1.default.createElement("div", { className: "row mb-3" },
                react_1.default.createElement("label", { htmlFor: "canvas{{ _uid }}", className: "col-sm-2 col-form-label" }, "Canvas"),
                react_1.default.createElement("div", { className: "col-sm-10" },
                    react_1.default.createElement("canvas", { ref: canvasRef, id: "canvas{{ _uid }}", width: data?.width, height: data?.height }))))));
});
exports.default = CanvasFlow;
