"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const header_1 = __importDefault(require("@uniflow-io/uniflow-client/src/components/flow/header"));
const form_input_1 = __importStar(require("@uniflow-io/uniflow-client/src/components/form-input"));
const flow_1 = require("@uniflow-io/uniflow-client/src/components/flow/flow");
const property_accessor_1 = __importDefault(require("property-accessor"));
const free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const ObjectFlow = (0, flow_1.flow)((props, ref) => {
    const { onPop, onUpdate, onPlay, isPlaying, data, clients } = props;
    (0, react_1.useImperativeHandle)(ref, () => ({
        onSerialize: () => {
            let object = transform();
            return JSON.stringify([data?.variable, object]);
        },
        onDeserialize: (data) => {
            let [variable, object] = data ? JSON.parse(data) : [undefined, []];
            let keyValueList = reverseTransform(object);
            return { variable, keyValueList };
        },
        onCompile: () => {
            if (!data || !data.variable) {
                return '';
            }
            let object = transform();
            return data.variable + ' = ' + JSON.stringify(object);
        },
        onExecute: async (runner) => {
            if (data?.variable) {
                let context = runner.getContext();
                if (context[data.variable]) {
                    let object = context[data.variable];
                    let keyValueList = reverseTransform(object);
                    onUpdate({ ...data, keyValueList });
                }
                else {
                    return runner.run();
                }
            }
        }
    }), [data]);
    const transform = () => {
        return data?.keyValueList?.reduce(function (object, item) {
            if (item.key) {
                let value = item.value;
                if (typeof value === 'string' && /^[0-9]+$/.test(value)) {
                    value = Number.parseInt(value);
                }
                try {
                    let accessor = new property_accessor_1.default(object);
                    accessor.set(item.key, value);
                }
                catch (e) { }
            }
            return object;
        }, {}) || {};
    };
    const reverseTransform = (object) => {
        let flatten = function (data, accessors = []) {
            return Object.entries(data).reduce(function (list, item) {
                if (typeof item[1] === 'object') {
                    list = list.concat(flatten(item[1], accessors.concat([item[0]])));
                }
                else {
                    let key = item[0];
                    for (let i = accessors.length - 1; i >= 0; i--) {
                        if (key[0] !== '[') {
                            key = '.' + key;
                        }
                        if (/^[0-9]+$/.test(accessors[i])) {
                            key = '[' + accessors[i] + ']' + key;
                        }
                        else {
                            key = accessors[i] + key;
                        }
                    }
                    list.push({ key: key, value: item[1] });
                }
                return list;
            }, []);
        };
        return flatten(object);
    };
    const onChangeVariable = (variable) => {
        onUpdate({
            ...data,
            variable
        });
    };
    const onUpdateItemKey = (event, index) => {
        onUpdate({
            ...data,
            keyValueList: data?.keyValueList?.map((item, i) => {
                if (i !== index) {
                    return item;
                }
                return {
                    ...item,
                    ...{ key: event.target.value },
                };
            }),
        });
    };
    const onUpdateItemValue = (event, index) => {
        onUpdate({
            ...data,
            keyValueList: data?.keyValueList?.map((item, i) => {
                if (i !== index) {
                    return item;
                }
                return {
                    ...item,
                    ...{ value: event.target.value },
                };
            }),
        });
    };
    const onRemoveItem = (event, index) => {
        event.preventDefault();
        let keyValueList = data?.keyValueList?.slice() || [];
        keyValueList.splice(index, 1);
        onUpdate({ ...data, keyValueList });
    };
    const onAddItem = (event) => {
        event.preventDefault();
        let keyValueList = data?.keyValueList?.slice() || [];
        keyValueList.push({ key: '', value: '' });
        onUpdate({ ...data, keyValueList });
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(header_1.default, { title: "Object", clients: clients, isPlaying: isPlaying, onPlay: onPlay, onPop: onPop }),
        react_1.default.createElement("form", { className: "form-sm-horizontal" },
            react_1.default.createElement(form_input_1.default, { id: "variable", type: form_input_1.FormInputType.TEXT, label: "Variable", value: data?.variable, onChange: onChangeVariable }),
            data?.keyValueList?.map((item, index) => (react_1.default.createElement("div", { className: "row mb-3", key: index },
                react_1.default.createElement("div", { className: "col-sm-4 offset-sm-2" },
                    react_1.default.createElement("input", { type: "text", value: item.key, onChange: event => onUpdateItemKey(event, index), className: "form-control", placeholder: "key" })),
                react_1.default.createElement("div", { className: "col-sm-6" },
                    react_1.default.createElement("div", { className: "input-group" },
                        react_1.default.createElement("input", { type: "text", value: item.value, onChange: event => onUpdateItemValue(event, index), className: "form-control", placeholder: "value" }),
                        react_1.default.createElement("button", { type: "button", className: "input-group-text", onClick: event => {
                                onRemoveItem(event, index);
                            } },
                            react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faTimes })))))))),
        react_1.default.createElement("div", { className: "row mb-3" },
            react_1.default.createElement("div", { className: "col-sm-10 offset-sm-2" },
                react_1.default.createElement("button", { type: "submit", onClick: onAddItem, className: "btn btn-primary" }, "Add Item")))));
});
exports.default = ObjectFlow;
