"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const header_1 = __importDefault(require("@uniflow-io/uniflow-client/src/components/flow/header"));
const form_input_1 = __importStar(require("@uniflow-io/uniflow-client/src/components/form-input"));
const flow_1 = require("@uniflow-io/uniflow-client/src/components/flow/flow");
const use_state_ref_1 = require("@uniflow-io/uniflow-client/src/hooks/use-state-ref");
const interfaces_1 = require("@uniflow-io/uniflow-client/src/models/interfaces");
var PromptChoicheType;
(function (PromptChoicheType) {
    PromptChoicheType["STRING"] = "string";
    PromptChoicheType["TEXT"] = "text";
    PromptChoicheType["FILE"] = "file";
})(PromptChoicheType || (PromptChoicheType = {}));
const PromptFlow = (0, flow_1.flow)((props, ref) => {
    const { onPop, onUpdate, onPlay, isPlaying, data, clients } = props;
    const [promptInput, setPromptInput] = (0, react_1.useState)(false);
    const [message, setMessage] = (0, react_1.useState)();
    const [input, setInput, inputRef] = (0, use_state_ref_1.useStateRef)(undefined);
    const inputResolve = (0, react_1.useRef)();
    (0, react_1.useImperativeHandle)(ref, () => ({
        onSerialize: () => {
            return JSON.stringify([data?.variable, data?.messageVariable, data?.type]);
        },
        onDeserialize: (data) => {
            const [variable, messageVariable, type] = data ? JSON.parse(data) : [undefined, undefined, undefined];
            return { variable, messageVariable, type };
        },
        onCompile: (client) => {
            if (!data || !data.variable) {
                return '';
            }
            if (client === interfaces_1.ClientType.NODE) {
                return `
        (function() {
          return new Promise(function(resolve) {
            const rl = readline.createInterface({
              input: process.stdin,
              output: process.stdout
            });
        
            rl.question(${data.messageVariable
                    ? data.messageVariable
                    : JSON.stringify('prompt')} + ': ', function(answer) {
              ${data.variable} = answer
        
              rl.close()
            });
        
            rl.on('close', () => {
              resolve()
            })
          })
        })()
        `;
            }
            return data.variable + ' = ' + JSON.stringify(inputRef.current || '');
        },
        onExecute: async (runner) => {
            let context = runner.getContext();
            if (data?.messageVariable && context[data.messageVariable]) {
                setMessage(context[data.messageVariable]);
            }
            else {
                setMessage(undefined);
            }
            setPromptInput(true);
            setInput(undefined);
            await new Promise(resolve => {
                inputResolve.current = resolve;
            });
            setPromptInput(false);
            runner.run();
        }
    }), [data]);
    const onChangeVariable = (variable) => {
        onUpdate({
            ...data,
            variable
        });
    };
    const onChangeMessageVariable = (messageVariable) => {
        onUpdate({
            ...data,
            messageVariable
        });
    };
    const onChangeType = (type) => {
        onUpdate({
            ...data,
            type
        });
    };
    const onChangeInputString = (input) => {
        setInput(input);
    };
    const onChangeInputText = (input) => {
        setInput(input);
    };
    const onChangeInputFile = (event) => {
        event.persist();
        event.preventDefault();
        let file = event.target.files[0];
        return new Promise((resolve, error) => {
            let reader = new FileReader();
            reader.onerror = error;
            reader.onload = e => {
                setInput(e.target?.result?.toString());
                resolve(undefined);
            };
            reader.readAsText(file);
        });
    };
    const onInputSave = event => {
        event.preventDefault();
        if (inputResolve.current) {
            inputResolve.current(undefined);
        }
    };
    const allChoices = {
        [PromptChoicheType.STRING]: 'String',
        [PromptChoicheType.TEXT]: 'Text',
        [PromptChoicheType.FILE]: 'File',
    };
    let choices = {}, clientKeyChoices = [];
    if (clients.length === 1 && clients.indexOf('uniflow') !== -1) {
        clientKeyChoices = [PromptChoicheType.STRING, PromptChoicheType.TEXT, PromptChoicheType.FILE];
    }
    else if (clients.length === 1 && clients.indexOf('node') !== -1) {
        clientKeyChoices = [PromptChoicheType.STRING];
    }
    else if (clients.length === 2 &&
        clients.indexOf('node') !== -1 &&
        clients.indexOf('uniflow') !== -1) {
        clientKeyChoices = [PromptChoicheType.STRING];
    }
    choices = clientKeyChoices.reduce(function (value, key) {
        value[key] = allChoices[key];
        return value;
    }, choices);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(header_1.default, { title: "Prompt", clients: clients, isPlaying: isPlaying, onPlay: onPlay, onPop: onPop }),
        react_1.default.createElement("form", { className: "form-sm-horizontal" },
            react_1.default.createElement(form_input_1.default, { id: "variable", type: form_input_1.FormInputType.TEXT, label: "Variable", value: data?.variable, onChange: onChangeVariable }),
            react_1.default.createElement(form_input_1.default, { id: "messageVariable", type: form_input_1.FormInputType.TEXT, label: "Message", value: data?.messageVariable, onChange: onChangeMessageVariable }),
            react_1.default.createElement(form_input_1.default, { id: "type", type: form_input_1.FormInputType.SELECT, label: "Type", value: data?.type, onChange: onChangeType, options: Object.keys(choices).map((type) => {
                    return { value: type, label: choices[type] };
                }) }),
            promptInput && message && (react_1.default.createElement("div", { className: "row mb-3" },
                react_1.default.createElement("div", { className: "offset-md-2 col-sm-10" }, message))),
            promptInput && data?.type === PromptChoicheType.STRING && (react_1.default.createElement(form_input_1.default, { id: "input-string", type: form_input_1.FormInputType.TEXT, label: "Input", value: input, onChange: onChangeInputString })),
            promptInput && data?.type === PromptChoicheType.TEXT && (react_1.default.createElement(form_input_1.default, { id: "input-text", type: form_input_1.FormInputType.EDITOR, label: "Input", value: input, onChange: onChangeInputText })),
            promptInput && data?.type === PromptChoicheType.FILE && (react_1.default.createElement("div", { className: "row mb-3" },
                react_1.default.createElement("label", { htmlFor: "input-file", className: "col-sm-2 col-form-label" }, "Input"),
                react_1.default.createElement("div", { className: "col-sm-10" },
                    react_1.default.createElement("input", { id: "input-file", type: "file", onChange: onChangeInputFile, className: "form-control" }))))),
        promptInput && (react_1.default.createElement("div", { className: "row mb-3" },
            react_1.default.createElement("div", { className: "col-sm-10 offset-sm-2" },
                react_1.default.createElement("button", { type: "submit", onClick: onInputSave, className: "btn btn-primary" }, "Ok"))))));
});
exports.default = PromptFlow;
