"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const header_1 = __importDefault(require("@uniflow-io/uniflow-client/src/components/flow/header"));
const form_input_1 = __importStar(require("@uniflow-io/uniflow-client/src/components/form-input"));
const flow_1 = require("@uniflow-io/uniflow-client/src/components/flow/flow");
const TextFlow = (0, flow_1.flow)((props, ref) => {
    const { onPop, onUpdate, onPlay, isPlaying, data, clients } = props;
    (0, react_1.useImperativeHandle)(ref, () => ({
        onSerialize: () => {
            return JSON.stringify([data?.variable, data?.text]);
        },
        onDeserialize: (data) => {
            const [variable, text] = data ? JSON.parse(data) : [undefined, undefined];
            return { variable, text };
        },
        onCompile: () => {
            if (!data || !data.variable) {
                return '';
            }
            let text = data.text || '';
            text = JSON.stringify(text);
            return data.variable + ' = ' + text;
        },
        onExecute: async (runner) => {
            if (data && data.variable) {
                let context = runner.getContext();
                if (context[data.variable]) {
                    onUpdate({
                        ...data,
                        text: context[data.variable]
                    });
                }
                else {
                    return runner.run();
                }
            }
        }
    }), [data]);
    const onChangeVariable = (variable) => {
        onUpdate({
            ...data,
            variable
        });
    };
    const onChangeText = (text) => {
        onUpdate({
            ...data,
            text
        });
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(header_1.default, { title: "Text", clients: clients, isPlaying: isPlaying, onPlay: onPlay, onPop: onPop }),
        react_1.default.createElement("form", { className: "form-sm-horizontal" },
            react_1.default.createElement(form_input_1.default, { id: "variable", type: form_input_1.FormInputType.TEXT, label: "Variable", value: data?.variable, onChange: onChangeVariable }),
            react_1.default.createElement(form_input_1.default, { id: "text", type: form_input_1.FormInputType.EDITOR, label: "Text", value: data?.text, onChange: onChangeText }))));
});
exports.default = TextFlow;
